/*###########################################################################
#                                                                           #
#                       vs1053b 䃂W[                              #
#                                                                           #
###########################################################################*/
#ifndef __VS1053B_H__
#define __VS1053B_H__

#include <avr/io.h>
#include <avr/pgmspace.h>

/* Kppb`gp^sgp`		*/
#define VS_LOAD_USER_CODE    0
#define VS_IMAFIX            0
#define VS_VORBISPATCH       0
#define VS_SPECTRUM_ANALYZER 0
#define VS_SPECTRUM_VALUES  14			/* XyAif[^	*/

/*	NbN`iύXj		*/
#define VS_FCPU	12288000L

/* DREQ擾iύXj				*/
#define VS_GET_DREQ()		( PINE & _BV(5) )

/* XDCSiύXj				*/
#define VS_ENABLE_XDCS()	( PORTE &= ~_BV(4) )
#define VS_DISABLE_XDCS()	( PORTE |=  _BV(4) )

/* XCSiύXj				*/
#define VS_ENABLE_XCS()		( PORTE &= ~_BV(3) )
#define VS_DISABLE_XCS()	( PORTE |=  _BV(3) )

/* XRESETiύXj				*/
#define VS_ENABLE_XRESET()	( PORTE &= ~_BV(6) )
#define VS_DISABLE_XRESET()	( PORTE |=  _BV(6) )

/* BEEP / Zbg̉ʒ`iύXj	*/
#define _VS_BEEP_VOLUME		  ( 100 )
#define _VS_DEFAULT_VOLUME	  ( 130 )

/* WX^`								*/
#define SCI_MODE 		0x00		/* [hERg[							*/
#define SCI_STATUS      0x01		/* VS1053b̃Xe[^X							*/
#define SCI_BASS		0x02		/* ̒ቹ/Rg[					*/
#define SCI_CLOCKF		0x03		/* NbNg{}`vC				*/
#define SCI_DECODE_TIME 0x04		/* bPʂł̍Đ							*/
#define SCI_AUDATA		0x05		/* eI[fBIEf[^						*/
#define SCI_WRAM		0x06		/* RAM[h/Cg								*/
#define SCI_WRAMADDR	0x07		/* RAM[h/Cg̃x[XEAhX			*/
#define SCI_HDAT0		0x08		/* Xg[Ewb_Ef[^0					*/
#define SCI_HDAT1		0x09		/* Xg[Ewb_Ef[^1					*/
#define SCI_AIADDR		0x0a		/* AvP[V̊JnAhX				*/
#define SCI_VOL			0x0b		/* {[ERg[						*/
#define SCI_AICTRL0		0x0c		/* AvP[VERg[EWX^0	*/
#define SCI_AICTRL1		0x0d		/* AvP[VERg[EWX^1	*/
#define SCI_AICTRL2		0x0e		/* AvP[VERg[EWX^2	*/
#define SCI_AICTRL3		0x0f		/* AvP[VERg[EWX^3	*/

/* WX^ SCI_MODE l`					*/
#define SM_DIFF 		 0x0001		/* 					OFF:ʏ̓I[fBI / ON:`l𔽓]		*/
#define SM_LAYER12  	 0x0002		/* MPEGCI/II		OFF:֎~                 / ON:						*/
#define SM_RESET    	 0x0004		/* \tgZbg		OFF:ZbgȂ       / ON:Zbg(A)	*/
#define SM_CANCEL		 0x0008 	/* t@C̃fR[hf	0:  1:L										*/
#define SM_EARSPEAKER_LO 0x0010		/* EarSpeaker̉ʐݒ															*/
#define SM_TESTS		 0x0020		/* SDIeXg		OFF:֎~                 / ON:						*/
#define SM_STREAM		 0x0040		/* Xg[E[h	OFF:֎~                 / ON:						*/
#define SM_EARSPEAKER_HI 0x0080		/* EarSpeakeȑʐݒ															*/
#define SM_DACT			 0x0100		/* DCLKANeBuGbW	OFF:オ           / ON:					*/
#define SM_SDIORD		 0x0200		/* SDIrbg			OFF:MSbt@[Xg        / ON:LSbt@[Xg				*/
#define SM_SDISHARE		 0x0400		/* SPI CS̋p			OFF:֎~                 / ON:						*/
#define SM_SDINEW		 0x0800		/* lCeBuE[h	OFF:֎~                 / ON:						*/
#define SM_ADPCM		 0x1000 	/* ADPCM^@\		OFF:֎~				 / ON:						*/
#define SM_LINE1		 0x4000 	/* }CN/C1I   OFF:}CN               / ON:C1					*/
#define SM_CLK_RANGE	 0x8000 	/* ̓NbNEW OFF:12`13MHz            / ON:24`26MHz					*/

/* GNXgEp[^AhX`	*/
#define X_PLAYSPEED		( 0x1e04 )
#define X_BYTERATE		( 0x1e05 )
#define X_ENDFILLBYTE	( 0x1e06 )
#define X_POSITION_MSEC ( 0x1e27 )
#define X_BYTES_LEFT    ( 0x1e2a )

/* NbN{EWMA/AAC̒ǉ{`	*/
#define VS_MULTIPLE10		( 0x0000 )		/* VS_FCPU x 1.0{					*/
#define VS_MULTIPLE20		( 0x2000 )		/* VS_FCPU x 2.0{					*/
#define VS_MULTIPLE25		( 0x4000 )		/* VS_FCPU x 2.5{					*/
#define VS_MULTIPLE30		( 0x6000 )		/* VS_FCPU x 3.0{					*/
#define VS_MULTIPLE35		( 0x7000 )		/* VS_FCPU x 3.5{					*/
#define VS_MULTIPLE40		( 0xa000 )		/* VS_FCPU x 4.0{					*/
#define VS_MULTIPLE45		( 0xc000 )		/* VS_FCPU x 4.5{					*/
#define VS_MULTIPLE50		( 0xe000 )		/* VS_FCPU x 5.0{					*/

#define VS_ADD_MULTIPLE00	( 0x0000 )		/* WMA/AACĐ̒ǉ{ + 0.0	*/
#define VS_ADD_MULTIPLE10	( 0x0800 )		/* WMA/AACĐ̒ǉ{ + 1.0	*/
#define VS_ADD_MULTIPLE15	( 0x1000 )		/* WMA/AACĐ̒ǉ{ + 1.5	*/
#define VS_ADD_MULTIPLE20	( 0x1800 )		/* WMA/AACĐ̒ǉ{ + 2.0	*/

/*	֐vg^Cv錾	*/
void vsInit( void );
void vsResetPlayMode( void );
void vsResetRecordAdpcm( void );
void vsSetClockMultiple( uint16_t multiple ,uint16_t add_multiple );
void vsHighPitchedSoundEmphasis( uint8_t f ,int8_t lv );
void vsBassEmphasis( uint8_t f ,uint8_t lv );
void vsSetEarSpeaker( uint8_t lv );
void vsSetVolume( uint8_t vol );
uint8_t vsGetVolume( void );
void vsBeep( uint16_t f ,uint8_t n ,uint8_t length );
void vsLoadUserCode( const prog_uint16_t *code );
uint16_t vsOutFill( uint8_t data ,uint16_t n );
uint16_t vsOutStream( const uint8_t *p ,uint16_t n );
void vsWriteByte( uint8_t data );
void vsRegWrite( uint8_t reg ,uint16_t data );
uint16_t vsRegRead( uint8_t reg );
uint32_t vsReadXmemDword( uint16_t addr );
uint16_t vsReadXmem( uint16_t addr );
void vsWriteXmem( uint16_t addr ,uint16_t data );

#endif
