/*###########################################################################
#                                                                           #
#                  @@@@OtBbN֘AW[						#
#                                                                           #
#  			SPItbVSPI|[gɐڑĂ鎖O			#
#  		xłグׂɒڃWX^(SPDR/SPSR)𑀍삵Ă		#
#                                                                           #
###########################################################################*/
#define __GRAPHIC_C__
#include <string.h>
#include <avr/io.h>
#include <avr/pgmspace.h>

#include "FatFs/tff.h"
#include "string_func.h"
#include "at45db161d.h"
#include "zy_fgd1442701v1.h"
#include "flash_sys.h"
#include "vs1053b.h"
#include "graphic.h"

/* XyAi\pp[^		*/
#define SP_WIDTH 6
#define SP_HEIGHT 31	// ύXs!!

/* tHgTCYl			*/
#define FONT_WIDTH_MAX	16				/* ő剡hbg	*/
#define FONT_HEIGHT_MAX	16				/* őchbg	*/
#define FONT_DATA_MAX_LENGTH ( ( ( FONT_WIDTH_MAX + 7 ) / 8 ) * FONT_HEIGHT_MAX )

/* [Jϐ錾(sys_draw.cŎQƂׂɃO[o錾)	*/
G_BGMODE g_bgMode = G_BGMODE_COLOR;					/* BG[h						*/
uint16_t g_bgColor = 0;								/* BGF							*/
FLASH_FS_INFO g_bgInfo;								/* BGt@C				*/

/* [J֐vg^Cv錾	*/
static uint8_t g_getFontxInfo( uint16_t index ,FONT *fnt );
static FONT *g_getFontData( FONT_SET *fontSet ,uint16_t code ,uint8_t *fontDatas );

/*****************************************************************************
*									BGʐݒ
* FG_BGMODE  mode  G_BG_COLOR : PF[h
*                       G_BG_IMAGE : C[W[h(128dotX128dotŒ)
*		uint16_t value  mode = G_BG_COLOR : wiF
*					    mode = G_BG_IMAGE : C[Wt@CCfbNXԍ
* ߒlFuint8_t         0:OK  !0:NG
*****************************************************************************/
uint8_t g_setBG( G_BGMODE mode ,uint16_t value )
{
	if ( mode == G_BGMODE_IMAGE ) {

		/* t@C擾			*/
		flashFsGetIndex( value ,&g_bgInfo );
		if ( g_bgInfo.ftype != FLASH_FS_IMAGE ) {	/* 摜t@Cł͂Ȃ	*/
			return ( 1 );
		}

		if ( ( g_bgInfo.width != 128 ) || ( g_bgInfo.height != 128 ) ) {	/* 摜TCYKiO	*/
			return ( 2 );
		}
	}

	g_bgMode = mode;
	g_bgColor = value;

	return ( 0 );
}

/*****************************************************************************
*									ʃNA
* Fvoid
* ߒlFvoid
*****************************************************************************/
void g_cls( void )
{
	/* PF[h						*/
	if ( g_bgMode == G_BGMODE_COLOR ) {
		uint8_t bc1 = (uint8_t)( g_bgColor >> 8 );
		uint8_t bc2 = (uint8_t)g_bgColor;

		LCD_SET_COLUM_ADDRESS( 0 ,SCREEN_WIDTH - 1 );
		LCD_SET_ROW_ADDRESS( 0 ,SCREEN_HEIGHT - 1 );
		LCD_CMD = LCD_RAMWR;

		for ( uint16_t size = SCREEN_WIDTH * SCREEN_HEIGHT ;size ;size-- ) {
			LCD_DAT = bc1;
			LCD_DAT = bc2;
		}

	/* C[W[h					*/
	} else {
		g_drawFlashImage( g_bgColor ,G_OPAQUE ,RGB( 0 ,0 ,0 ) ,0 ,0 ,SCREEN_WIDTH - 1 ,SCREEN_HEIGHT - 1 );
	}
}

/*****************************************************************************
*								`
* FG_DRAWMODE  mode  `惂[h G_OPAQUE      ʏ\
*                                    G_HALF_ALL    `
*                                    G_TRANSPARENT ʏ\
*                                    G_HALF        `
*		uint8_t    x1    n_XW
*		uint8_t    y1    n_YW
* 		uint8_t    x2    I_XW
*		uint8_t    y2    I_YW
*		uint16_t   color \F
* ߒlFvoid
*****************************************************************************/
void g_drawLine( G_DRAWMODE mode ,uint8_t x1 ,uint8_t y1 ,uint8_t x2 ,uint8_t y2 ,uint16_t color )
{
	uint8_t dx = 0;					/* X1,X2̍Βl					*/
	uint8_t dy = 0;					/* Y1,Y2̍Βl					*/
	uint8_t sx = 0;					/* XWړ 0:ړ 1: 2:E	*/
	uint8_t sy = 0;					/* YWړ 0:ړ 1: 2:	*/
	uint8_t e = 0;					/* 덷									*/
	uint8_t i;						/* 厲WJE^						*/

	/* X1,X2̐ΒlXړvZ	*/
	if ( x1 > x2 ) {
		dx = x1 - x2;
		sx = 1;
	} else if ( x1 < x2 ) {
		dx = x2 - x1;
		sx = 2;
	}

	/* Y1,Y2̐ΒlYړvZ	*/
	if ( y1 > y2 ) {
		dy = y1 - y2;
		sy = 1;
	} else if ( y1 < y2 ) {
		dy = y2 - y1;
		sy = 2;
	}

	/* ̑傫厲Ƃ	*/
	if ( dx >= dy ) {
		for ( i = 0 ;i <= dx ;i++ ) {
			g_drawBoxF( mode ,x1 ,y1 ,x1 ,y1 ,color );
			e += dy;
			if ( e > dx ) {
				e -= dx;
				if ( sy == 1 ) {
					y1--;
				} else if ( sy == 2 ) {
					y1++;
				}
			}
			if ( sx == 1 ) {
				x1--;
			} else if ( sx == 2 ) {
				x1++;
			}
		}

	} else {
		for ( i = 0 ;i <= dy ;i++ ) {
			g_drawBoxF( mode ,x1 ,y1 ,x1 ,y1 ,color );
			e += dx;
			if ( e > dy ) {
				e -= dy;
				if ( sx == 1 ) {
					x1--;
				} else if ( sx == 2 ) {
					x1++;
				}
			}
			if ( sy == 1 ) {
				y1--;
			} else if ( sy == 2 ) {
				y1++;
			}
		}
	}
}

/*****************************************************************************
*						hԂ`\
* FG_DRAWMODE  mode  `惂[h G_OPAQUE      ʏ\
*                                    G_HALF_ALL    `
*                                    G_TRANSPARENT ʏ\
*                                    G_HALF        `
*		uint8_t    x1    \̈`XW
*		uint8_t    y1    \̈`YW
* 		uint8_t    x2    \̈`EXW
*		uint8_t    y2    \̈`EYW
*		uint16_t   color \F
* ߒlFvoid
*****************************************************************************/
void g_drawBoxF( G_DRAWMODE mode ,uint8_t x1 ,uint8_t y1 ,uint8_t x2 ,uint8_t y2 ,uint16_t color )
{
	uint16_t pos = 0;
	uint16_t page = 0;
	uint16_t offset = 0;
	uint8_t bc1 = 0 ,bc2 = 0;
	uint8_t ic1,ic2;
	uint8_t bgGetFlag;
	uint8_t x ,y;
	uint8_t rgb[3];

	/* OiFݒ				*/
	ic1 = (uint8_t)( color >> 8 );
	ic2 = (uint8_t)color;

	/* wiF擾				*/
	bgGetFlag = 0;
	if  ( mode & 0x80 ) {							/* BGKv?		*/
		if ( g_bgMode == G_BGMODE_COLOR ) {			/* PF[h?		*/
			bc1 = (uint8_t)( g_bgColor >> 8 );
			bc2 = (uint8_t)g_bgColor;
		} else {
			bgGetFlag = 1;
		}
	}

	/* XJnW/XIWݒ		*/
	lcdRectClip( &x1 ,&y1 ,&x2 ,&y2 );

	/* LCD\JnʒuZbg		*/
	LCD_SET_COLUM_ADDRESS( x1 ,x2 );
	LCD_SET_ROW_ADDRESS( y1 ,y2 );
	LCD_CMD = LCD_RAMWR;

	/* BGC[WC擪vZ		*/
	if ( bgGetFlag ) {
		pos = ( (uint16_t)y1 * 256 ) + ( (uint16_t)x1 * 2 );
		page = g_bgInfo.topPage + (uint16_t)( pos / 512 );
		offset = (uint16_t)( pos % 512 );
	}

	for ( y = y1 ;y <= y2 ;y++ ) {

		/* BGC[WCݒ		*/
		if ( bgGetFlag ) {
			flashContinuousArrayRead( page ,offset );
		}

		for ( x = x1 ;x <= x2 ;x++ ) {

			/* BGC[WsNZF擾			*/
			if ( bgGetFlag ) {
				SPDR = 0xff;
				while( !( SPSR & _BV(SPIF) ) );
				bc1 = SPDR;

				SPDR = 0xff;
				while( !( SPSR & _BV(SPIF) ) );
				bc2 = SPDR;
			}

			/* `						*/
			if ( ( mode == G_HALF_ALL ) || ( mode == G_HALF ) ) {
				rgb[0] = ( ( ic1 >> 3 ) + ( bc1 >> 3 ) ) / 2;
				rgb[1] = ( ( ( ( ic1 << 3 ) & 0x3f ) | ( ic2 >> 5 ) ) + ( ( ( bc1 << 3 ) & 0x3f ) | ( bc2 >> 5 ) ) ) / 2;
				rgb[2] = ( ( ic2 & 0x1f ) + ( bc2 & 0x1f ) ) / 2;
				LCD_DAT = ( ( rgb[0] << 3 ) | ( rgb[1] >> 3 ) );
				LCD_DAT = ( ( rgb[1] << 5 ) | rgb[2] );

			/* ʏ`							*/
			} else {
				LCD_DAT = ic1;
				LCD_DAT = ic2;
			}
		}

		/* BGC[WCXebv	*/
		if ( bgGetFlag ) {
			offset += 256;
			if ( offset >= 512 ) {
				offset -= 512;
				page++;
			}
		}
	}
}

/*****************************************************************************
*				SPItbVɊi[Ă摜\
* Fuint16_t   index C[Wt@CCfbNXԍ
*		G_DRAWMODE  mode  `惂[h G_OPAQUE      C[Ŵ܂ܕ`
*                                    G_HALF_ALL    SsNZ𔼓`
*                                    G_TRANSPARENT wF𓧖ŕ` / ̑̐Fʏ`
*                                    G_HALF        wF𓧖ŕ` / ̑̐F𔼓`
*		uint16_t   color FL[( G_TRANSPARENT / G_HALF ̎ɋ@\ )
*		uint8_t    x1    \̈`XW
*		uint8_t    y1    \̈`YW
* 		uint8_t    x2    \̈`EXW
*		uint8_t    y2    \̈`EYW
* ߒlFuint8_t          0:OK !0:NG
*****************************************************************************/
uint8_t g_drawFlashImage( uint16_t index ,G_DRAWMODE mode ,uint16_t color ,uint8_t x1 ,uint8_t y1 ,uint8_t x2 ,uint8_t y2 )
{
	uint16_t bgPage = 0;			/* wiBGC[WSPItbVʒu	*/
	uint16_t bgOffset = 0;

	uint16_t imgPage = 0;			/* \C[WSPItbVʒu		*/
	uint16_t imgOffset = 0;

	uint8_t bgImg[256];				/* wiBGC[WCf[^obt@	*/
	uint8_t *bgp = bgImg;			/* bgImgւ̃|C^					*/

	FLASH_FS_INFO imgInfo;			/* C[Wt@C					*/

	uint8_t rgb[3];					/* rgbpobt@					*/
	uint8_t bgGetFlag;

	uint8_t bc1 = 0 ,bc2 = 0;		/* BGsNZF							*/
	uint8_t ic1 = 0 ,ic2 = 0;		/* \C[WsNZF				*/
	uint8_t kc1 = 0 ,kc2 = 0;		/* KEYF								*/

	uint8_t x ,y;
	uint8_t gx ,gy;

	/* C[Wt@C擾		*/
	flashFsGetIndex( index ,&imgInfo );				/* t@C擾		*/

	/* XJnW/XIWݒ		*/
	lcdRectClip( &x1 ,&y1 ,&x2 ,&y2 );

	/* LCD\JnʒuZbg		*/
	LCD_SET_COLUM_ADDRESS( x1 ,x2 );
	LCD_SET_ROW_ADDRESS( y1 ,y2 );
	LCD_CMD = LCD_RAMWR;

	/* \C[W\Jnʒu	*/
	imgPage = imgInfo.topPage;
	imgOffset = 0;

	/* mode == G_OPAQUE ̏ꍇ̏î܂ܕ\j	*/
	if ( mode == G_OPAQUE ) {

		for ( gy = 0 ,y = y1 ;( y <= y2 ) && ( gy < imgInfo.height ) ;y++ ) {

			flashContinuousArrayRead( imgPage ,imgOffset );
			for ( gx = 0 ,x = x1 ;( x <= x2 ) && ( gx < imgInfo.width ) ;x++ ) {
				SPDR = 0xff; while( !( SPSR & _BV(SPIF) ) ); LCD_DAT = SPDR;
				SPDR = 0xff; while( !( SPSR & _BV(SPIF) ) ); LCD_DAT = SPDR;
			}

			/* ̕\y[WԍvZ		*/
			imgOffset += imgInfo.bytesPerLine;
			imgPage += ( imgOffset / 512 );
			imgOffset %= 512;
		}

	} else {

		/* L[Fl				*/
		kc1 = (uint8_t)( color >> 8 );
		kc2 = (uint8_t)color;

		/* wiF擾				*/
		bgGetFlag = 0;
		if  ( mode & 0x80 ) {							/* BGKv?		*/
			if ( g_bgMode == G_BGMODE_COLOR ) {			/* PF[h?		*/
				bc1 = (uint8_t)( g_bgColor >> 8 );
				bc2 = (uint8_t)g_bgColor;
			} else {
				bgGetFlag = 1;
			}
		}

		/* BGC[W\Jnʒu	*/
		if ( bgGetFlag ) {
			bgOffset = ( (uint16_t)y1 * g_bgInfo.bytesPerLine ) + ( (uint16_t)x1 * 2 );
			bgPage = g_bgInfo.topPage + ( bgOffset / 512 );
			bgOffset %= 512;
		}

		for ( gy = 0 ,y = y1 ;( y <= y2 ) && ( gy < imgInfo.height ) ;y++ ,gy++ ) {

			/* BGC[W̃Cf[^擾	*/
			if ( bgGetFlag ) {
				flashContinuousArrayRead( bgPage ,bgOffset );
				flashReadBLOCK( bgImg ,g_bgInfo.bytesPerLine );
				bgOffset += g_bgInfo.bytesPerLine;
				bgPage += ( bgOffset / 512 );
				bgOffset %= 512;
				bgp = bgImg;
			}

			/* PC\[v			*/
			flashContinuousArrayRead( imgPage ,imgOffset );
			for ( gx = 0 ,x = x1 ;( x <= x2 ) && ( gx < imgInfo.width ) ;x++ ,gx++ ) {

				/* \C[WsNZ擾	*/
				ic1 = flashReadBYTE();
				ic2 = flashReadBYTE();

				/* wiC[WsNZ擾	*/
				if ( bgGetFlag ) {
					bc1 = *bgp++;
					bc2 = *bgp++;
				}

				/* SF𔼓\									*/
				if ( mode == G_HALF_ALL ) {
					rgb[0] = ( ( ic1 >> 3 ) + ( bc1 >> 3 ) ) / 2;
					rgb[1] = ( ( ( ( ic1 << 3 ) & 0x3f ) | ( ic2 >> 5 ) ) + ( ( ( bc1 << 3 ) & 0x3f ) | ( bc2 >> 5 ) ) ) / 2;
					rgb[2] = ( ( ic2 & 0x1f ) + ( bc2 & 0x1f ) ) / 2;
					LCD_DAT = ( ( rgb[0] << 3 ) | ( rgb[1] >> 3 ) );
					LCD_DAT = ( ( rgb[1] << 5 ) | rgb[2] );

				/* w̃L[𓧖\ / ̑̐F̂܂ܕ\	*/
				} else if ( mode == G_TRANSPARENT ) {
					if ( ( kc1 == ic1 ) && ( kc2 == ic2 ) ) {
						LCD_DAT = bc1;
						LCD_DAT = bc2;
					} else {
						LCD_DAT = ic1;
						LCD_DAT = ic2;
					}

				/* w̃L[𓧖\ / ̑̐F𔼓\	*/
				} else {
					if ( ( kc1 == ic1 ) && ( kc2 == ic2 ) ) {
						LCD_DAT = bc1;
						LCD_DAT = bc2;
					} else {
						rgb[0] = ( ( ic1 >> 3 ) + ( bc1 >> 3 ) ) / 2;
						rgb[1] = ( ( ( ( ic1 << 3 ) & 0x3f ) | ( ic2 >> 5 ) ) + ( ( ( bc1 << 3 ) & 0x3f ) | ( bc2 >> 5 ) ) ) / 2;
						rgb[2] = ( ( ic2 & 0x1f ) + ( bc2 & 0x1f ) ) / 2;
						LCD_DAT = ( ( rgb[0] << 3 ) | ( rgb[1] >> 3 ) );
						LCD_DAT = ( ( rgb[1] << 5 ) | rgb[2] );
					}
				}
			}

			/* \C[W̎̃CʒuvZ	*/
			imgOffset += imgInfo.bytesPerLine;
			imgPage += ( imgOffset / 512 );
			imgOffset %= 512;
		}
	}

	return ( 0 );
}

/*****************************************************************************
*							tHgZbg쐬
* Fuint16_t han   ptHgt@CCfbNXԍ
*       uint16_t zen   SptHgt@CCfbNXԍ
*		FONT_SET *fnt  tHgZbg\̂ւ̃|C^
* ߒlFuint8_t        0:OK !0:NG
*****************************************************************************/
uint8_t g_createFontSet( uint16_t han ,uint16_t zen ,FONT_SET *fnt )
{
	memset( fnt ,0x00 ,sizeof(FONT_SET) );

	if ( han != 0 ) {
		if ( g_getFontxInfo( han ,&fnt->hFont ) != 0 ) {
			return ( 1 );
		}
	}
	
	if ( zen != 0 ) {
		if ( g_getFontxInfo( zen ,&fnt->zFont ) != 0 ) {
			return ( 2 );
		}
	}

	return ( 0 );
}

/*****************************************************************************
*						VXetHg(5x7)ASCII\
* Fuint8_t    x       \JnXW
*		uint8_t    y       \JnYW
*       char       *str    \(S-JIS)
*		G_DRAWMODE mode    `惂[h G_OPAQUE      ʏ\
*                                     G_HALF_ALL    tHgEwi𔼓`
*                                     G_TRANSPARENT tHgʏ` / wi𓧖`
*                                     G_HALF        tHgʏ` / wi𔼓ŕ`
*       uint16_t fontColor \F
*		uint16_t bgColor   wiF( mode == G_TRANSPARENT͖)
*****************************************************************************/
void g_putsAscii( uint8_t x ,uint8_t y ,char *str ,G_DRAWMODE mode ,uint16_t fontColor ,uint16_t bgColor )
{
	uint8_t x2 ,y2;
	uint8_t dx ,dy;
	uint8_t bitData;
	uint8_t bgGetFlag;
	uint8_t fc1 ,fc2;								/* tHgF				*/
	uint8_t bc1 = 0 ,bc2 = 0;						/* BGsNZF				*/
	uint8_t kc1 ,kc2;								/* wiF					*/
	uint16_t bgPage = 0;
	uint16_t bgOffset = 0;
	uint16_t code;
	const prog_uint8_t *p;
	char *s;
	uint8_t rgb[3];

	/* tHg\F擾						*/
	fc1 = (uint8_t)( fontColor >> 8 );
	fc2 = (uint8_t)fontColor;

	/* wi\F擾							*/
	kc1 = (uint8_t)( bgColor >> 8 );
	kc2 = (uint8_t)bgColor;

	/* BGF擾									*/
	bgGetFlag = 0;
	if  ( mode & 0x80 ) {					/* BGKv?				*/
		if ( g_bgMode == G_BGMODE_COLOR ) {	/* PFBG[h?			*/
			bc1 = (uint8_t)( g_bgColor >> 8 );
			bc2 = (uint8_t)g_bgColor;
		} else {
			bgGetFlag = 1;
		}
	}

	/* \[v								*/	
	s = str;
	while ( x < SCREEN_WIDTH ) {

		/* ݈ʒu當R[hPo		*/
		/* tHgf[^擾					*/
		code = getCharCode( &s );
		if ( code == 0x0000 ) {
			break;
		}
		p = lcdGetFontImage( (char)code );

		/* \̈ݒ							*/
		x2 = x + 5;
		y2 = y + 7 - 1;
		lcdRectClip( &x ,&y ,&x2 ,&y );

		LCD_SET_COLUM_ADDRESS( x ,x2 );
		LCD_SET_ROW_ADDRESS( y ,y2 );
		LCD_CMD = LCD_RAMWR;

		/* BGC[W擪tbVAhXvZ	*/
		if ( bgGetFlag ) {
			bgOffset = ( (uint16_t)y * g_bgInfo.bytesPerLine ) + ( (uint16_t)x * 2 );
			bgPage = g_bgInfo.topPage + ( bgOffset / 512 );
			bgOffset %= 512;
		}

		for ( dy = y ;dy <= y2 ;dy++ ) {

			/* BGC[WAhXݒ					*/
			if ( bgGetFlag ) {
				flashContinuousArrayRead( bgPage ,bgOffset );
			}

			bitData = pgm_read_byte( p++ );
			for ( dx = x ;dx <= x2 ;dx++ ) {

				/* BGC[Wf[^擾					*/
				if ( bgGetFlag ) {
					SPDR = 0xff;
					while( !( SPSR & _BV(SPIF) ) );
					bc1 = SPDR;

					SPDR = 0xff;
					while( !( SPSR & _BV(SPIF) ) );
					bc2 = SPDR;
				}

				/* ʏ\							*/
				if ( mode == G_OPAQUE ) {
					if ( bitData & 0x80 ) {
						LCD_DAT = fc1;
						LCD_DAT = fc2;
					} else {
						LCD_DAT = kc1;
						LCD_DAT = kc2;
					}

				/* tHgEwi𔼓`		*/
				} else if ( mode == G_HALF_ALL ) {
					if ( bitData & 0x80 ) {
						rgb[0] = ( ( fc1 >> 3 ) + ( bc1 >> 3 ) ) / 2;
						rgb[1] = ( ( ( ( fc1 << 3 ) & 0x3f ) | ( fc2 >> 5 ) ) + ( ( ( bc1 << 3 ) & 0x3f ) | ( bc2 >> 5 ) ) ) / 2;
						rgb[2] = ( ( fc2 & 0x1f ) + ( bc2 & 0x1f ) ) / 2;
					} else {
						rgb[0] = ( ( kc1 >> 3 ) + ( bc1 >> 3 ) ) / 2;
						rgb[1] = ( ( ( ( kc1 << 3 ) & 0x3f ) | ( kc2 >> 5 ) ) + ( ( ( bc1 << 3 ) & 0x3f ) | ( bc2 >> 5 ) ) ) / 2;
						rgb[2] = ( ( kc2 & 0x1f ) + ( bc2 & 0x1f ) ) / 2;
					}
					LCD_DAT = ( ( rgb[0] << 3 ) | ( rgb[1] >> 3 ) );
					LCD_DAT = ( ( rgb[1] << 5 ) | rgb[2] );

				/* G_TRANSPARENT tHgʏ` / wi𓧖`	*/
				} else if ( mode == G_TRANSPARENT ) {
					if ( bitData & 0x80 ) {
						LCD_DAT = fc1;
						LCD_DAT = fc2;
					} else {
						LCD_DAT = bc1;
						LCD_DAT = bc2;
					}

				/* tHgʏ` / wi𔼓ŕ`				*/
				} else {
					if ( bitData & 0x80 ) {
						LCD_DAT = fc1;
						LCD_DAT = fc2;
					} else {
						rgb[0] = ( ( kc1 >> 3 ) + ( bc1 >> 3 ) ) / 2;
						rgb[1] = ( ( ( ( kc1 << 3 ) & 0x3f ) | ( kc2 >> 5 ) ) + ( ( ( bc1 << 3 ) & 0x3f ) | ( bc2 >> 5 ) ) ) / 2;
						rgb[2] = ( ( kc2 & 0x1f ) + ( bc2 & 0x1f ) ) / 2;
						LCD_DAT = ( ( rgb[0] << 3 ) | ( rgb[1] >> 3 ) );
						LCD_DAT = ( ( rgb[1] << 5 ) | rgb[2] );
					}
				}

				 bitData <<= 1;
			}

			/* BG[h̃tbVAhXύX	*/
			if ( bgGetFlag ) {
				bgOffset += 256;
				if ( bgOffset >= 512 ) {
					bgOffset -= 512;
					bgPage++;
				}
			}
		}

		x += 6;
	}
}

/*****************************************************************************
*						wtHgŕ\
* FFONT_SET *fontSet   tHgZbg
*       uint8_t  x          \JnXW
*		uint8_t  y          \JnYW
*       char     *char      \(S-JIS)
*		G_DRAWMODE  mode    `惂[h G_OPAQUE      ̂܂ܕ`
*                                      G_HALF_ALL    tHgEwi𔼓`
*                                      G_TRANSPARENT tHgʏ` / wi𓧖`
*                                      G_HALF        tHgʏ` / wi𔼓ŕ`
*       uint16_t fontColor  \F
*		uint16_t bgColor    wiF
* ߒlFvoid
******************************************************************************/
void g_puts( FONT_SET *fontSet ,uint8_t x ,uint8_t y ,char *str ,G_DRAWMODE mode ,uint16_t fontColor ,uint16_t bgColor )
{
	_g_puts( fontSet ,x ,y ,NA ,0 ,str ,mode ,fontColor ,bgColor );
}

/*****************************************************************************
*						wtHgŕ\
* FFONT_SET *fontSet   tHgZbg
*       uint8_t  x          \JnXW
*		uint8_t  y          \JnYW
*		uint8_t  xclip	    E[XW
*		uint8_t  xposOffset \ItZbgl
*       char     *str       \(S-JIS)
*		G_DRAWMODE mode     `惂[h G_OPAQUE      ʏ\
*                                      G_HALF_ALL    tHgEwi𔼓`
*                                      G_TRANSPARENT tHgʏ` / wi𓧖`
*                                      G_HALF        tHgʏ` / wi𔼓ŕ`
*       uint16_t fontColor  \F
*		uint16_t bgColor    wiF( mode == G_TRANSPARENT͖)
* ߒlFuint8_t             0:S\ł  !0:\Ȃ
*****************************************************************************/
uint8_t _g_puts( FONT_SET *fontSet ,uint8_t x ,uint8_t y ,uint8_t xclip ,uint8_t xposOffset ,char *str ,G_DRAWMODE mode ,uint16_t fontColor ,uint16_t bgColor )
{
	uint8_t x2 = 0 ,y2 = 0;
	uint8_t dx = 0 ,dy = 0;
	uint8_t cx = 0 ,cy = 0;
	uint8_t *p1 = NULL;
	uint8_t *p2 = NULL;
	uint8_t bitCount = 0;
	uint8_t bitData = 0;
	uint8_t bgGetFlag;
	uint8_t fc1 ,fc2;								/* tHgF				*/
	uint8_t bc1 = 0 ,bc2 = 0;						/* BGsNZF				*/
	uint8_t kc1 ,kc2;								/* wiF					*/
	uint8_t xposOffsetByte = 0;
	uint8_t xposOffsetBit = 0;
	uint16_t bgPage = 0;
	uint16_t bgOffset = 0;
	uint16_t code = 0;
	uint8_t fontDatas[ FONT_DATA_MAX_LENGTH ];
	uint8_t ret;
	FONT *font = NULL;
	char *s;
	uint8_t rgb[3];

	/* W`FbN							*/
	if ( xclip == NA ) {
		cx = SCREEN_WIDTH - 1;
	} else {
		cx = xclip;
	}
	cy = SCREEN_HEIGHT - 1;
	if ( ( x > cx ) || ( y > cy ) ) {	/* \͈͊O?	*/
		return ( 0 );
	}

	/* tHg\F擾						*/
	fc1 = (uint8_t)( fontColor >> 8 );
	fc2 = (uint8_t)fontColor;

	/* wi\F擾							*/
	kc1 = (uint8_t)( bgColor >> 8 );
	kc2 = (uint8_t)bgColor;

	/* BGF擾									*/
	bgGetFlag = 0;
	if  ( mode & 0x80 ) {					/* BGKv?				*/
		if ( g_bgMode == G_BGMODE_COLOR ) {	/* PFBG[h?			*/
			bc1 = (uint8_t)( g_bgColor >> 8 );
			bc2 = (uint8_t)g_bgColor;
		} else {
			bgGetFlag = 1;
		}
	}

	/* tHg\ItZbgl						*/
	if ( xposOffset != 0 ) {
		xposOffsetByte = xposOffset / 8;
		xposOffsetBit = xposOffset % 8;
	}

	/* \[v								*/	
	s = str;
	ret = 1;
	code = 0xffff;
	while ( x <= cx ) {

		/* ݈ʒu當R[hPo		*/
		/* tHgf[^擾					*/
		if ( code ) {
			code = getCharCode( &s );
			if ( code == 0x0000 ) {
				ret = 0;
				if ( xclip == NA ) {
					break;
				}
				font = g_getFontData( fontSet ,0x0020 ,fontDatas );
			} else {
				font = g_getFontData( fontSet ,code ,fontDatas );
			}
		}

		/* \̈ݒ							*/
		x2 = x + font->xsize - 1;
		y2 = y + font->ysize - 1;
		if ( x2 > cx ) x2 = cx;
		if ( y2 > cy ) y2 = cy;
		dx = x2 - x + 1;
		dy = y2 - y + 1;
		x2 -= xposOffset;
		LCD_SET_COLUM_ADDRESS( x ,x2 );
		LCD_SET_ROW_ADDRESS( y ,y2 );
		LCD_CMD = LCD_RAMWR;

		/* BGC[W擪tbVAhXvZ	*/
		if ( bgGetFlag ) {
			bgOffset = ( (uint16_t)y * g_bgInfo.bytesPerLine ) + ( (uint16_t)x * 2 );
			bgPage = g_bgInfo.topPage + ( bgOffset / 512 );
			bgOffset %= 512;
		}

		p1 = fontDatas;
		while ( dy-- ) {
		
			/* BGC[WAhXݒ					*/
			if ( bgGetFlag ) {
				flashContinuousArrayRead( bgPage ,bgOffset );
			}

			/* ItZbg\L莞̏			*/
			p2 = p1;
			if ( xposOffset != 0 ) {
				if ( xposOffsetByte != 0 ) {
					p2 += xposOffsetByte;
				}

				if ( xposOffsetBit != 0) {
					 bitData = *p2++;
					 bitData <<= xposOffsetBit;
				}
			}

			for ( bitCount = xposOffset ;bitCount < dx ;bitCount++ ) {

				/* tHgf[^1oCgo		*/
				if ( ( bitCount % 8 ) == 0 ) {
					 bitData = *p2++;
				}

				/* BGC[Wf[^擾					*/
				if ( bgGetFlag ) {
					SPDR = 0xff;
					while( !( SPSR & _BV(SPIF) ) );
					bc1 = SPDR;

					SPDR = 0xff;
					while( !( SPSR & _BV(SPIF) ) );
					bc2 = SPDR;
				}

				/* ʏ\							*/
				if ( mode == G_OPAQUE ) {
					if (  bitData & 0x80 ) {
						LCD_DAT = fc1;
						LCD_DAT = fc2;
					} else {
						LCD_DAT = kc1;
						LCD_DAT = kc2;
					}

				/* tHgEwi𔼓`		*/
				} else if ( mode == G_HALF_ALL ) {
					if (  bitData & 0x80 ) {
						rgb[0] = ( ( fc1 >> 3 ) + ( bc1 >> 3 ) ) / 2;
						rgb[1] = ( ( ( ( fc1 << 3 ) & 0x3f ) | ( fc2 >> 5 ) ) + ( ( ( bc1 << 3 ) & 0x3f ) | ( bc2 >> 5 ) ) ) / 2;
						rgb[2] = ( ( fc2 & 0x1f ) + ( bc2 & 0x1f ) ) / 2;
					} else {
						rgb[0] = ( ( kc1 >> 3 ) + ( bc1 >> 3 ) ) / 2;
						rgb[1] = ( ( ( ( kc1 << 3 ) & 0x3f ) | ( kc2 >> 5 ) ) + ( ( ( bc1 << 3 ) & 0x3f ) | ( bc2 >> 5 ) ) ) / 2;
						rgb[2] = ( ( kc2 & 0x1f ) + ( bc2 & 0x1f ) ) / 2;
					}
					LCD_DAT = ( ( rgb[0] << 3 ) | ( rgb[1] >> 3 ) );
					LCD_DAT = ( ( rgb[1] << 5 ) | rgb[2] );

				/* G_TRANSPARENT tHgʏ` / wi𓧖`	*/
				} else if ( mode == G_TRANSPARENT ) {
					if (  bitData & 0x80 ) {
						LCD_DAT = fc1;
						LCD_DAT = fc2;
					} else {
						LCD_DAT = bc1;
						LCD_DAT = bc2;
					}

				/* tHgʏ` / wi𔼓ŕ`				*/
				} else {
					if (  bitData & 0x80 ) {
						LCD_DAT = fc1;
						LCD_DAT = fc2;
					} else {
						rgb[0] = ( ( kc1 >> 3 ) + ( bc1 >> 3 ) ) / 2;
						rgb[1] = ( ( ( ( kc1 << 3 ) & 0x3f ) | ( kc2 >> 5 ) ) + ( ( ( bc1 << 3 ) & 0x3f ) | ( bc2 >> 5 ) ) ) / 2;
						rgb[2] = ( ( kc2 & 0x1f ) + ( bc2 & 0x1f ) ) / 2;
						LCD_DAT = ( ( rgb[0] << 3 ) | ( rgb[1] >> 3 ) );
						LCD_DAT = ( ( rgb[1] << 5 ) | rgb[2] );
					}
				}

				 bitData <<= 1;
			}

			/* tHgf[^̎̍s						*/
			p1 += font->linePerBytes;

			/* BG[h̃tbVAhXύX	*/
			if ( bgGetFlag ) {
				bgOffset += 256;
				if ( bgOffset >= 512 ) {
					bgOffset -= 512;
					bgPage++;
				}
			}
		}

		x += ( dx - xposOffset );
		xposOffset = 0;
	}

	return ( ret );
}

/*****************************************************************************
*						XN[\
* FFONT_SET *fontSet tHgZbg
*		G_SCROLL *sp   	  XN[p[^\
*		uint8_t  x        \JnXW
*		uint8_t  y        \JnYW
*		uint8_t  xclip    E[XW
*		uint8_t  blank    \̃uN
*		char     *str     \
*		G_DRAWMODE  mode    `惂[h G_OPAQUE      ̂܂ܕ`
*                                      G_HALF_ALL    tHgEwi𔼓`
*                                      G_TRANSPARENT tHgʏ` / wi𓧖`
*                                      G_HALF        tHgʏ` / wi𔼓ŕ`
*       uint16_t fontColor  \F
*		uint16_t bgColor    wiF
* ߒlFvoid
*	g_scrollNext()֐ĂԑOɖ{֐ŃXN[̏Kv
*   *str / *fontSet / *sp ̓XN[rŔjȂlɂĂ
*****************************************************************************/
void g_scrollFirst( FONT_SET *fontSet ,G_SCROLL *sp ,uint8_t x ,uint8_t y ,uint8_t xclip ,uint8_t blank ,char *str ,G_DRAWMODE mode ,uint16_t fontColor ,uint16_t bgColor )
{
	FONT *font;

	/* \					*/
	if ( _g_puts( fontSet ,x ,y ,xclip ,0 ,str ,mode ,fontColor ,bgColor ) == 0 ) {
		memset( sp ,0x00 ,sizeof(G_SCROLL) );

	} else {
		sp->enable = 1;
		sp->blankCount = blank;
		sp->setBlank = blank;
		sp->fontSet = fontSet;
		sp->s = str;
		sp->ss = str;
		sp->xposOffset = 0;
		sp->mode = mode;
		sp->fontColor = fontColor;
		sp->bgColor = bgColor;
		sp->x1 = x;
		sp->x2 = xclip;
		sp->x = x;
		sp->y = y;
		sp->code = getCharCode( &str );
		font = g_getFontData( sp->fontSet ,sp->code ,NULL );
		sp->fontWidth = font->xsize;
	}

}

/*****************************************************************************
*						XN[\
* FG_SCROLL *sp   	  XN[p[^\
* ߒlFvoid
*****************************************************************************/
void g_scrollNext( G_SCROLL *sp )
{
	char *s;
	FONT *font;

	if ( sp->enable ) {

		/* \ItZbgE擪|C^vZ	*/
		if ( sp->x == sp->x1 ) {
			sp->xposOffset++;
			if ( ( sp->xposOffset % sp->fontWidth ) == 0 ) {
				getCharCode( &sp->ss );				/* |C^i߂	*/
				s = sp->ss;
				sp->code = getCharCode( &s );
				sp->xposOffset = 0;
				if ( sp->code != 0 ) {
					font = g_getFontData( sp->fontSet ,sp->code ,NULL );
					sp->fontWidth = font->xsize;
				}
			}
		} else {
			sp->x--;
		}

		/* \				*/
		if ( sp->code != 0x0000 ) {
			_g_puts( sp->fontSet ,sp->x ,sp->y ,sp->x2 ,sp->xposOffset ,sp->ss ,sp->mode ,sp->fontColor ,sp->bgColor );

		/* uN				*/
		} else if ( sp->blankCount != 0 ) {
			if ( --sp->blankCount != 0 ) {
				_g_puts( sp->fontSet ,sp->x1 ,sp->y ,sp->x2 ,0 ,"" ,sp->mode ,sp->fontColor ,sp->bgColor );

			} else {						/* uNIH			*/
				s = sp->s;
				sp->code = getCharCode( &s );
				font = g_getFontData( sp->fontSet ,sp->code ,NULL );
				sp->fontWidth = font->xsize;
				sp->ss = sp->s;
				sp->xposOffset = 0;
				sp->x = sp->x2;
				sp->blankCount = sp->setBlank;
				_g_puts( sp->fontSet ,sp->x ,sp->y ,sp->x2 ,0 ,sp->ss ,sp->mode ,sp->fontColor ,sp->bgColor );
			}
		}
	}
}

/*****************************************************************************
*									XyAi\
* Fuint16_t *dat XyAif[^l
*		G_DRAWMODE  mode  `惂[h G_OPAQUE      XyNgʏ`^wi`
*                                    G_HALF_ALL    XyNg𔼓`^wi𔼓`
*                                    G_TRANSPARENT XyNgʏ`^wi[`
*                                    G_HALF        XyNg𔼓`^wi[`
*		uint8_t    x      \̈`XW
*		uint8_t    y      \̈`YW
* ߒlFvoid
*****************************************************************************/
void g_drawSpectrum( uint16_t *dat ,G_DRAWMODE  mode ,uint8_t x ,uint8_t y )
{
	/* XyNgFe[u(31)	*/
	static const prog_uint8_t colors[ 31 * 2 ] = {
		0xf8,0x00 ,0xfa,0x24 ,0xfa,0xc5 ,0xfb,0x45 ,0xfb,0xc6 ,0xfc,0x46 ,0xfc,0xc6 ,0xfd,0x47 ,
		0xfd,0xc7 ,0xfe,0x47 ,0xfe,0xc8 ,0xff,0x48 ,0xff,0xc9 ,0xf7,0xc9 ,0xe7,0xaa ,0xdf,0x8b ,
		0xcf,0x6b ,0xc7,0x4c ,0xbf,0x4d ,0xb7,0x2d ,0xaf,0x0e ,0x9f,0x0f ,0x96,0xef ,0x8e,0xd0 ,
		0x86,0xd0 ,0x7e,0xb1 ,0x76,0xb2 ,0x76,0xb3 ,0x7e,0xd4 ,0x7e,0xf5 ,0x7f,0x16
	};

	const prog_uint8_t *p;
	uint16_t pos = 0;
	uint16_t page = 0;
	uint16_t offset = 0;
	uint8_t currentValue;
	uint8_t peakValue;
	uint16_t data;
	uint8_t wy;
	uint8_t wx;
	uint8_t rgb[3];
	uint8_t bc1 = 0 ,bc2 = 0;
	uint8_t ic1,ic2;

	/* F					*/
	const uint8_t kc1 = (uint8_t)( RGB(31,11,83) >> 8 );
	const uint8_t kc2 = (uint8_t)RGB(31,11,83);

	/* wiF擾				*/
	if ( g_bgMode == G_BGMODE_COLOR ) {			/* PF[h?		*/
		bc1 = (uint8_t)( g_bgColor >> 8 );
		bc2 = (uint8_t)g_bgColor;
	}

	/* Y\͈͐ݒ(ŒlȂ̂Ń[vOŐݒ)	*/
	LCD_SET_ROW_ADDRESS( y ,y + SP_HEIGHT - 1 );

	for ( uint8_t i = 0 ;i < VS_SPECTRUM_VALUES ;i++ ) {

		/* XyAif[^			*/
		data = *dat++;
		currentValue =  (uint8_t)( data & 0x3f );
		peakValue = (uint8_t)( ( data & 0x0fc0 ) >> 6 );
		if ( currentValue > peakValue ) {
			currentValue = peakValue;
		}

		/* BGC[WC擪vZ		*/
		pos = ( (uint16_t)y * 256 ) + ( (uint16_t)x * 2 );
		page = g_bgInfo.topPage + (uint16_t)( pos / 512 );
		offset = (uint16_t)( pos % 512 );

		/* X\͈͐ݒ				*/
		LCD_SET_COLUM_ADDRESS( x ,x + SP_WIDTH - 1 );
		LCD_CMD = LCD_RAMWR;

		wy = SP_HEIGHT;
		p = colors;
		while ( wy-- ) {

			/* BGC[WCݒ		*/
			flashContinuousArrayRead( page ,offset );
			
			/* OiFݒ				*/
			ic1 = pgm_read_byte( p++ );
			ic2 = pgm_read_byte( p++ );

			wx = SP_WIDTH;
			while ( wx-- ) {

				/* BGC[WsNZF擾			*/
				SPDR = 0xff;
				while( !( SPSR & _BV(SPIF) ) );
				bc1 = SPDR;

				SPDR = 0xff;
				while( !( SPSR & _BV(SPIF) ) );
				bc2 = SPDR;

				/* XyNgʏ\^wiwi[`	*/
				if ( mode == G_OPAQUE ) {
					if ( ( peakValue ) && ( wy == ( peakValue - 1 ) ) ) {		/* s[Nz[hF	*/
						LCD_DAT = 0xf8;
						LCD_DAT = 0x00;
					} else if ( ( currentValue == 0 ) || ( wy > ( currentValue - 1 ) ) ) {	/* wi	*/
						LCD_DAT = kc1;
						LCD_DAT = kc2;
					} else {													/* LF		*/
						LCD_DAT = ic1;
						LCD_DAT = ic2;
					}

				/* LFEwi𔼓`			*/
				} else {
					if ( ( peakValue ) && ( wy == ( peakValue - 1 ) ) ) {		/* s[Nz[hF	*/
						ic1 = 0xf8;
						ic2 = 0x00;
					} else if ( ( currentValue == 0 ) || ( wy > ( currentValue - 1 ) ) ) {	/* wi	*/
						ic1 = 0x00;
						ic2 = 0x00;
					}

					rgb[0] = ( ( ic1 >> 3 ) + ( bc1 >> 3 ) ) / 2;
					rgb[1] = ( ( ( ( ic1 << 3 ) & 0x3f ) | ( ic2 >> 5 ) ) + ( ( ( bc1 << 3 ) & 0x3f ) | ( bc2 >> 5 ) ) ) / 2;
					rgb[2] = ( ( ic2 & 0x1f ) + ( bc2 & 0x1f ) ) / 2;
					LCD_DAT = ( ( rgb[0] << 3 ) | ( rgb[1] >> 3 ) );
					LCD_DAT = ( ( rgb[1] << 5 ) | rgb[2] );
				}
			}

			/* BGC[WCXebv	*/
			offset += 256;
			if ( offset >= 512 ) {
				offset -= 512;
				page++;
			}
		}

		x += ( SP_WIDTH + 1 );
	}
}

/*****************************************************************************
*	SPItbVɊi[Ă FONTX2 `̃t@C擾
* Fuint16_t index t@CCfbNXԍ
*       FONT     *fnt  tHgi[̈
* ߒlFuint8_t        0:OK !0:NG
*****************************************************************************/
static uint8_t g_getFontxInfo( uint16_t index ,FONT *fnt )
{
	FLASH_FS_INFO inf;
	uint32_t base;
	char buf[18];

	memset( fnt ,0x00 ,sizeof(FONT) );

	/* t@C擾					*/
	flashFsGetIndex( index ,&inf );
	if ( inf.fname[0] == 0x00 ) {
		return ( 1 );
	}

	/* 擪f[^擾(18bytes)			*/
	base = inf.topPage * 512L;
	flashRead( base ,buf ,18 );

	/* "FONTX2"ʎqmF				*/
	if ( memcmp_P( &buf[0] ,PSTR("FONTX2") ,6 ) != 0 ) {
		return ( 2 );
	}

	/* TCY擾						*/
	fnt->xsize = buf[14];
	if ( fnt->xsize > FONT_WIDTH_MAX ) {
		return ( 3 );
	}
	/* cTCY擾						*/
	fnt->ysize = buf[15];
	if ( fnt->ysize > FONT_HEIGHT_MAX ) {
		return ( 4 );
	}

	/* R[h^Cv擾					*/
	fnt->codeType = buf[16];
	if ( ( fnt->codeType != 0 ) && ( fnt->codeType != 1 ) ) {
		return ( 5 );
	}

	/* 1C̃oCgvZ			*/
	fnt->linePerBytes = ( fnt->xsize + 7 ) / 8;

	/* 1̃oCgvZ				*/
	fnt->charPerBytes = fnt->ysize * fnt->linePerBytes;

	if ( fnt->codeType == 1 ) {

		/* Gg[擾					*/
		fnt->tnum = buf[17];

		/* Gg[̐擪ʒu				*/
		fnt->entPage = ( base + 18L ) / 512L;
		fnt->entOffset = ( base + 18L ) % 512L;

		/* tHgf[^擪ʒuvZ		*/
		fnt->dataTop = base + 18L + ( (uint32_t)fnt->tnum * 4L );

	} else {
		fnt->dataTop = base + 17L;
	}

	return ( 0 );
}

/*****************************************************************************
*						wR[htHgf[^擾
* FFONT_SET  *fontSet   tHgZbg
*		uint16_t  code       R[h( ASCII / S-JIS )
*		uint8_t   *fontDatas tHgf[^i[̈( FONT_DATA_MAX_LENGTH )
* ߒlFFONT *               擾tHg
*****************************************************************************/
static FONT *g_getFontData( FONT_SET *fontSet ,uint16_t code ,uint8_t *fontDatas )
{
	uint32_t addr;
	uint16_t st = 0;
	uint16_t ed = 0;
	uint16_t i;
	FONT *font;

	/* S-JISR[h̏ꍇ̃tHgf[^擾	*/
	if ( code & 0xff00 ) {
		font = &fontSet->zFont;

		/* Gg[e[uR[h	*/
		uint16_t index = 0;
		flashContinuousArrayRead( font->entPage ,font->entOffset );
		for ( i = 0 ;i < font->tnum ;i++ ) {
			flashReadBLOCK( &st ,2 );
			flashReadBLOCK( &ed ,2 );
			if ( ( st <= code ) && ( ed >= code ) ) {
				index += ( code - st );
				break;
			}
			index += ( ( ed - st ) + 1 );
		}

		if ( i < font->tnum ) {		/* Gg[ĂR[hH		*/
			code = index;
		} else {					/* Gg[ĂȂR[hH	*/
			font = &fontSet->hFont;
			code = 0x20;
		}

	/* ASCIIR[h̏ꍇ̃tHgf[^擾	*/
	} else {
		font = &fontSet->hFont;
	}

	/* tHgf[^SPItbV擾		*/
	if ( fontDatas != NULL ) {
		addr = font->dataTop + ( (uint32_t)code * (uint32_t)font->charPerBytes );
		flashRead( addr ,fontDatas ,font->charPerBytes );
	}

	return ( font );
}

