/*###########################################################################
#                                                                           #
#  							yĐC								#
#                                                                           #
###########################################################################*/
#define __SCREEN001_C__
#include "project.h"

/* [Jϐ錾					*/
static uint8_t seekPos = 0;				/* V[No[l						*/
static uint8_t backupSeekPos = 0;		/* V[No[lޔp				*/
static uint32_t fileBlockSize = 0L;		/* Đ̧ق̼ް1̻ؕ	*/
static uint16_t backupBitRate = 0;		/* rbg[gޔp				*/
static uint16_t backupSampleRate = 0;	/* Tv[gޔp				*/

/* [J֐vg^Cv錾		*/
static void changePlayMode_AfterPorcess( uint8_t screenUpdateFlag );
static void getBitrateSampleRate( uint16_t *sampleRate ,uint16_t *bitRate );

/*****************************************************************************
*							v[[Cʏ
* Fvoid
* ߒlFvoid
*****************************************************************************/
void menu001( void )
{
	eep.screenIndex = 1;					/* 샂[hݒiv[[j	*/

	/* VXeϐ					*/
	sys.backupPath[0] = sys.backupPath[1] = 0xff;
	sys.backupPath[2] = sys.backupPath[3] = 0x00;
	sys.screenBrightness = eep.screenBrightness;
	sys.screenOffCountDownTimer = eep.screenOffTimer;
	sys.notProccesCountDownTimer = NOT_PROCESS_SHUTDOWN_TIME;

	/* v[[ݒ					*/
	sys.flag_sdInsert = 0xff;
	sys.erroring = 0;
	while ( player_process() == PLAY_STS_NONE );
	sys.backupErroring = sys.erroring;
	changePlayMode_AfterPorcess( 1 );

	/* C[v			*/
	keysClear();							/* L[obt@NA			*/
	while ( 1 ) {
		wdt_reset();

		/* v[[obNOh					*/
		if ( player_process() != PLAY_STS_NONE ) {
			changePlayMode_AfterPorcess( 0 );
			keysClear();
		}

		/* VXe									*/
		systemProcess();

		/* 莞DSPւ̓]ꍇ̓Vbg_E*/
		if ( sys.playMode & PLAY_STS_DSP_BIT ) {
			sys.notProccesCountDownTimer = NOT_PROCESS_SHUTDOWN_TIME;
		} else if ( sys.notProccesCountDownTimer == 0 ) {
			shutdown( SHUTDOWN_NOT_PROCESS_TIMER );
		}

		/* ebv\									*/
		if ( !sys.countDownTimer2 ) {
			sys.countDownTimer2 = SCROLL_INTERVAL;
			sysDraw_scrollNext();

		/* XyAi\									*/
		} else if ( ( sys.enableSpectrum ) && ( !sys.countDownTimer1 ) ) {
			sys.countDownTimer1 = SP_INTERVAL;
			sysDraw_spectrum( 0 );
			sys.enableSpectrum = 0;

		/* Vbg_E^C}[\					*/
		} else if ( sys.tickShutdownCountDownTimer ) {
			if ( sys.tickShutdownCountDownTimer ) {
				sys.tickShutdownCountDownTimer = 0;
				sysDraw_shutDownButton();
			}

		} else if ( sys.playMode & PLAY_STS_DSP_BIT ) {

			/* V[No[\							*/
			seekPos = sys.playFL.fptr / fileBlockSize;
			if ( seekPos != backupSeekPos ) {
				backupSeekPos = seekPos;
				sysDraw_seekBar( seekPos );

			} else if ( sys.tickPlayTime ) {
				sys.tickPlayTime = 0;

				/* Đԕ\							*/
				sysDraw_playTime( sys.playTime / 100L );

				/* Tv[gErbg[g擾		*/
				uint16_t sampleRate;
				uint16_t bitRate;
				getBitrateSampleRate( &sampleRate ,&bitRate );

				/* Tv[g\					*/
				if ( backupSampleRate != sampleRate ) {
					backupSampleRate = sampleRate;
					sysDraw_sampleRate( sampleRate );
				}

				/* rbg[g\						*/
				if ( backupBitRate != bitRate ) {
					backupBitRate = bitRate;
					sysDraw_bitRate( bitRate );
				}
			}
		}

		/* {^										*/
		uint8_t ky = keysInkey();
		if ( ky != KEY_NOTHING ) {

			/* ԃ{^FVbg_E					*/
			if ( ky == ( KEY_RED | KEY_LONGPUSH_START ) ) {
				shutdown( SHUTDOWN_USER );

			/* {^Fݒ胁j[						*/
			} else if ( ky == ( KEY_BROWN | KEY_LONGPUSH_START ) ) {
				menu010();
				changePlayMode_AfterPorcess( 1 );
				keysClear();

			/* {^FWI[hJ					*/
			} else if ( ky == ( KEY_BLACK | KEY_LONGPUSH_START ) ) {
				player_pause();
				player_stop();
				player_sound( SOUND_CHANGE_MODE );
				break;

			/* {^ZFȍĐ							*/
			} else if ( ky == KEY_BLACK ) {
				if ( !( sys.playMode & PLAY_STS_ERROR_BIT ) ) {
					player_stop();						/* Đ~				*/
					sysDraw_playButton( BUTTON_ICON_FF ,ON );	/* ACR\	*/
					player_sound( SOUND_NEXT_MUSIC );	/* ȑ艹				*/
					player_play( PLAY_NEXT );			/* ̋ȂĐJn		*/
					changePlayMode_AfterPorcess( 0 );
				}
				keysClear();

			/* {^ZFOȍĐ							*/
			} else if ( ky == KEY_BROWN ) {
				if ( !( sys.playMode & PLAY_STS_ERROR_BIT ) ) {
					player_stop();						/* Đ~				*/
					sysDraw_playButton( BUTTON_ICON_REV ,ON );	/* ACR\	*/
					if ( sys.playTime >= 300 ) {		/* 3bȏĐ?		*/
						player_sound( SOUND_TOP_OF_MUSIC );
						player_play( PLAY_CURRENT );
					} else {
						player_sound( SOUND_BACK_MUSIC );
						player_play( PLAY_BACK );
					}
					changePlayMode_AfterPorcess( 0 );
				}
				keysClear();

			/* ԃ{^ZF|[YE|[Y				*/
			} else if ( ky == KEY_RED ) {
				if ( !( sys.playMode & PLAY_STS_ERROR_BIT ) ) {

					/* |[Y	*/
					if ( sys.playMode == PLAY_STS_PAUSE ) {
						sysDraw_playButton( BUTTON_ICON_PLAY ,ON );
						player_sound( SOUND_PAUSE );

						if ( seekPos != backupSeekPos ) {
							memset( (void *)&eep.resume ,0x00 ,sizeof(eep.resume) );
							if ( seekPos != 0 ) {
								eep.resume.mode = RESUME_SEEK;
								eep.resume.fpos = (uint32_t)seekPos * fileBlockSize;
								eep.playTimeDisable = 1;	/* V[N̓fR[hԂ𖳌Ƃ			*/
								sys.playTime = 0L;			/* t@Cʒu玞Ԃ擾@ōl悤	*/
							}
						}

						player_play( PLAY_CURRENT );	/* ĐJn			*/

					/* |[YJn	*/
					} else {
						player_pause();
						player_sound( SOUND_PAUSE );
						sysDraw_playButton( BUTTON_ICON_PAUSE ,ON );
						sysDraw_spectrum( 0xff );
					}
				}
				keysClear();

			/* WO_CUPFUP / t@CV[N		*/
			} else if ( ky == KEY_JOGUP ) {
				/* |[YȊȌꍇ͉ʃAbv		*/
				if ( sys.playMode != PLAY_STS_PAUSE ) {
					if ( eep.volume < VOLUME_MAXVALUE ) {
						player_volume( ++eep.volume );
						sysDraw_volume();
					}

				/* |[Y̓V[No[̈ړ			*/
				} else if ( sys.playInfo.type != F_MIDI ) {		/* MIDI̓V[Ns	*/
					uint8_t n = seekPos + 5;
					if ( n > SEEK_VALUE_MAX ) {
						n = SEEK_VALUE_MAX;
					}
					if ( n != seekPos ) {
						seekPos = n;
						sysDraw_seekBar( seekPos );
					}
				}

			/* WO_CDOWNFDOWN / t@CV[N	*/
			} else if ( ky == KEY_JOGDOWN ) {
				/* |[YȊȌꍇ͉ʃ_E		*/
				if ( sys.playMode != PLAY_STS_PAUSE ) {
					if ( eep.volume > 0 ) {
						player_volume( --eep.volume );
						sysDraw_volume();
					}

				/* |[Y̓V[No[̈ړ			*/
				} else if ( sys.playInfo.type != F_MIDI ) {		/* MIDI̓V[Ns	*/
					uint8_t n = seekPos - 5;
					if ( n > SEEK_VALUE_MAX ) {
						n = 0;
					}
					if ( n != seekPos ) {
						seekPos = n;
						sysDraw_seekBar( seekPos );
					}
				}
			}

			/* e^C}[Zbg	*/
			sys.screenOffCountDownTimer = eep.screenOffTimer;
			sys.notProccesCountDownTimer = NOT_PROCESS_SHUTDOWN_TIME;
		}
	}
}

/*****************************************************************************
*						v[[ԕύX̏
* Fuint8_t screenUpdateFlag 0:󋵂ɉĉʘgĕ`
*								 1:Iɉʘgĕ`
* ߒlFvoid
*****************************************************************************/
static void changePlayMode_AfterPorcess( uint8_t screenUpdateFlag )
{
	char buf[24];

	/* DSP݋֎~							*/
	dspDisable();

	/* ϐNA								*/
	backupSeekPos = 0;
	seekPos = 0;
	fileBlockSize = 0L;
	backupBitRate = 0;
	backupSampleRate = 0;

	/* VXeϐݒ							*/
	sys.tickShutdownCountDownTimer = 1;
	sys.tickPlayTime = 1;
	sys.countDownTimer1 = 0;
	sys.countDownTimer2 = 0;
	sys.enableSpectrum = 0;

	/* ĐvZX㏈						*/
	if ( player_afterPorcess() ) {
		screenUpdateFlag = 1;
	}

	/*										*/
	/* ʕ`								*/
	/*										*/
	if ( screenUpdateFlag ) {
		lcdSetBrightness( 0 );
		sysDraw_cls();
		sysDraw_battery();
		sysDraw_volume();

		strcpy_P( buf ,PSTR("time") );
		g_putsAscii( 98 ,18 ,buf ,sys.gDrawMode ,0xffff ,0x0000 );

		strcpy_P( buf ,PSTR("Kbps") );
		g_putsAscii( 67 ,18 ,buf ,sys.gDrawMode ,0xffff ,0x0000 );
	
		strcpy_P( buf ,PSTR("KHz") );
		g_putsAscii( 67 ,26 ,buf ,sys.gDrawMode ,0xffff ,0x0000 );
	}

	sysDraw_sampleRate( 0xffff );
	sysDraw_bitRate( 0xffff );
	sysDraw_playTime( 0xffff );
	sysDraw_repetButton();
	sysDraw_shutDownButton();
	sysDraw_spectrum( 0xff );
	sysDraw_scrollFirst( NULL );

	if ( sys.erroring != 0 ) {
		sysDraw_fileType( F_OTHER );
		sysDraw_seekBar( 0xff );
		sysDraw_playButton( BUTTON_ICON_STOP ,OFF );

	} else {
		/* V[No[ϐ				*/
		fileBlockSize = sys.playFL.fsize / SEEK_VALUE_MAX;
		seekPos = sys.playFL.fptr / fileBlockSize;
		backupSeekPos = 0xff;

		sysDraw_fileType( sys.playInfo.type );
		sysDraw_seekBar( seekPos );
		sysDraw_playButton( ( sys.playMode == PLAY_STS_PAUSE ) ? BUTTON_ICON_PAUSE : BUTTON_ICON_PLAY ,ON );
	}

	/* ʋPxݒ							*/
	if ( screenUpdateFlag != 0 ) {
		lcdSetBrightness( sys.screenBrightness );
	}
}

/*****************************************************************************
*					rbg[gETv[g擾
* Fuint16_t *sampleRate
*		uint16_t *bitRate
* ߒlFvoid
*****************************************************************************/
static void getBitrateSampleRate( uint16_t *sampleRate ,uint16_t *bitRate )
{
	/* MP3 rbg[ge[u`	*/
	static const prog_uint16_t tbl1[] = {  0 , 32 , 40 , 48 , 56 , 64 , 80 , 96 ,112 ,128 ,160 ,192 ,224 ,256 ,320 ,  0 };
	static const prog_uint16_t tbl2[] = {  0 ,  8 , 16 , 24 , 32 , 40 , 48 , 56 , 64 , 80 , 96 ,112 ,128 ,144 ,160 ,  0 };

	*sampleRate = 0;
	*bitRate = 0;

	/* TvO[gErbg[g擾					*/
	/* f[^^CvLPCM̏ꍇ̓t@Cwb_̏擾	*/
	/* MP3̏ꍇ̓e[u擾						*/
	/* LPCM/MP3ȊÓADSP擾							*/
	if ( sys.playInfo.type & 0x80 ) {
		if ( sys.dsp_hDat0 && sys.dsp_hDat1 && sys.dsp_auData ) {
			*sampleRate = sys.dsp_auData;
			if ( sys.playInfo.type == F_MP3 ) {
				if ( ( ( sys.dsp_hDat1 & 0x0018 ) >>  3 ) == 3 ) {
					*bitRate = pgm_read_word( &tbl1[ ( ( sys.dsp_hDat0 & 0xf000 ) >> 12 ) ] );
				} else {
					*bitRate = pgm_read_word( &tbl2[ ( ( sys.dsp_hDat0 & 0xf000 ) >> 12 ) ] );
				}
			} else {
				*bitRate = (uint16_t)( ( (uint32_t)sys.dsp_hDat0 * 8L ) / 1000L );
			}
		}
	} else {											/* LPCMf[^?						*/
		*sampleRate = sys.playInfo.samplesPerSeconds;	/* t@Cwb_擾			*/
		*bitRate = sys.playInfo.bitRate;				/* t@Cwb_擾			*/
	}

	if ( *sampleRate <= 8000 ) {
		*sampleRate = 0;
	}
}
