/*###########################################################################
#                                                                           #
#  							Eቹݒ								#
#                                                                           #
###########################################################################*/
#define __SCREEN012_C__
#include "project.h"

#define BX1 6
#define BY1 33
#define BX2 ( BX1 + 115 )
#define BY2 ( BY1 + 30 )

#define ZX ( BX1 + 22 )							/* _XW				*/
#define ZY ( BY1 + ( ( BY2 - BY1 ) / 2 ) )		/* _YW				*/

static uint8_t hi_freq;			/* g(1`15)KHzȏ	*/
static int8_t hi_lv;			/* x1.5db݂Ŏw(-8`7)		*/
static uint8_t low_freq;		/* g(2`15) Hzȉ̎g(20Hz`150Hz) */
static uint8_t low_lv;			/* x1db݂Ŏw(0`15)		*/
static uint8_t mode;			/* JOB_CACe					*/

/* [J֐vg^Cv錾			*/
static void drawFullScreen( void );
static void jogProcess( uint8_t ky );
static void drawGraph( void );
static void drawItem( uint8_t index ,uint8_t sel );

/*****************************************************************************
*							ቹE
* Fvoid
* ߒlFuint8_t 0:OK !0:ACh^C}[쓮
*****************************************************************************/
uint8_t menu012( void )
{
	hi_freq = eep.hi_freq;		/* g(1`15)KHzȏ	*/
	hi_lv = eep.hi_lv;			/* x1.5db݂Ŏw(-8`7)		*/
	low_freq = eep.low_freq;	/* g(2`15) Hzȉ̎g(20Hz`150Hz) */
	low_lv = eep.low_lv;		/* x1db݂Ŏw(0`15)		*/
	mode = 0;

	/* \								*/
	drawFullScreen();

	/*	C							*/
	sys.notProccesCountDownTimer = NOT_PROCESS_SHUTDOWN_TIME;
	while ( sys.notProccesCountDownTimer ) {

		/* Tuj[obNOh		*/
		player_backProcess_for_submenu( &drawFullScreen );

		/* {^					*/
		uint8_t ky = keysInkey();
		if ( ky != KEY_NOTHING ) {

			/* ԃ{^FVbg_E				*/
			if ( ky == ( KEY_RED | KEY_LONGPUSH_START ) ) {
				shutdown( SHUTDOWN_USER );

			/* {^ZF	LZ					*/
			} else if ( ky == KEY_BLACK ) {
				dspDisable();
				vsHighPitchedSoundEmphasis( eep.hi_freq ,eep.hi_lv );
				vsBassEmphasis( eep.low_freq ,eep.low_lv );
				if ( sys.playMode & PLAY_STS_DSP_BIT ) {
					dspEnable();
				}
				return ( 0 );

			/* ԃ{^ZFm							*/
			} else if ( ky == KEY_RED ) {
				eep.hi_freq = hi_freq;
				eep.hi_lv = hi_lv;
				eep.low_freq = low_freq;
				eep.low_lv = low_lv;
				return ( 0 );

			/* F{^ZFtB[h؂ւ			*/
			} else if ( ky == KEY_BROWN ) {
				if ( ( mode >= 0 ) && ( mode <= 3 ) ) {
					drawItem( mode ,0 );
					mode += 4;
					drawItem( mode ,1 );
				} else {
					drawItem( mode ,0 );
					mode -= 4;
					drawItem( mode ,1 );
				}

			/* WO_C								*/
			} else if ( ( ky == KEY_JOGUP ) || ( ky == KEY_JOGDOWN ) ) {
				jogProcess( ky );
			}

			/* ^C}[Zbg		*/
			sys.notProccesCountDownTimer = NOT_PROCESS_SHUTDOWN_TIME;
		}
	}

	return ( 1 );
}

/*****************************************************************************
*							ʕ\
* Fvoid
* ߒlFvoid
*****************************************************************************/
static void drawFullScreen( void )
{
	char buf[24];

	sys.screenOffCountDownTimer = 0xffff;
	sys.screenBrightness = eep.screenBrightness;

	/* \								*/
	lcdSetBrightness( 0 );
	sysDraw_cls();
	sysDraw_battery();

	strcpy_P( buf ,PSTR("ቹEݒ") );
	g_puts( &sys.fnt1 ,10 ,18 ,buf ,sys.gDrawMode ,RGB(255,255,255) ,RGB(0,96,0) );

	strcpy_P( buf ,PSTR("+") );
	g_putsAscii( BX1 + 6 ,ZY - 15 ,buf ,sys.gDrawMode ,RGB(255,150,0) ,RGB(0,0,0) );

	strcpy_P( buf ,PSTR("0db") );
	g_putsAscii( BX1 ,ZY - 4 ,buf ,sys.gDrawMode ,RGB(255,150,0) ,RGB(0,0,0) );

	strcpy_P( buf ,PSTR("-") );
	g_putsAscii( BX1 + 6 ,ZY + 8 ,buf ,sys.gDrawMode ,RGB(255,150,0) ,RGB(0,0,0) );

	g_drawBoxF( sys.gDrawMode ,ZX ,BY1 ,ZX ,BY2 ,RGB(255,150,0) );
	drawGraph();
	for ( uint8_t i = 0 ;i < 8 ;i++ ) {
		drawItem( i ,i == mode );
	}

	lcdSetBrightness( eep.screenBrightness );
	keysClear();
}

/*****************************************************************************
*						WO_CAbv̏
* Fuint8_t ky KEY_JOGDOWN / KEY_JOGUP
* ߒlFvoid
*****************************************************************************/
static void jogProcess( uint8_t ky )
{
	uint8_t updateFlag = 0;				/* 0:OtXV					*/
										/* 1:ቹXVL					*/
										/* 2:XVL					*/
										/* 3:p[^XV̂				*/

	/* ڕ̕`			*/
	if ( ky == KEY_JOGUP ) {
		if ( ( mode >= 0 ) && ( mode <= 2 ) ) {
			drawItem( mode ,0 );
			drawItem( ++mode ,1 );

		} else if ( mode == 4 ) {
			if ( low_freq < 15 ) {
				low_freq++;
				if ( low_lv != 0 ) {
					updateFlag = 1;
				} else {
					updateFlag = 3;
				}
			}
		} else if ( mode == 5 ) {
			if ( low_lv < 15 ) {
				low_lv++;
				updateFlag = 1;
			}
		} else if ( mode == 6 ) {
			if ( hi_freq < 15 ) {
				hi_freq++;
				if ( hi_lv != 0 ) {
					updateFlag = 2;
				} else {
					updateFlag = 3;
				}
			}
		} else if ( mode == 7 ) {
			if ( hi_lv < 7 ) {
				hi_lv++;
				updateFlag = 2;
			}
		}

	} else {
		if ( ( mode >= 1 ) && ( mode <= 3 ) ) {
			drawItem( mode ,0 );
			drawItem( --mode ,1 );

		} else if ( mode == 4 ) {
			if ( low_freq > 2 ) {
				low_freq--;
				if ( low_lv != 0 ) {
					updateFlag = 1;
				} else {
					updateFlag = 3;
				}
			}
		} else if ( mode == 5 ) {
			if ( low_lv > 0 ) {
				low_lv--;
				updateFlag = 1;
			}
		} else if ( mode == 6 ) {
			if ( hi_freq > 1 ) {
				hi_freq--;
				if ( hi_lv != 0 ) {
					updateFlag = 2;
				} else {
					updateFlag = 3;
				}
			}
		} else if ( mode == 7 ) {
			if ( hi_lv > -8 ) {
				hi_lv--;
				updateFlag = 2;
			}
		}
	}

	/* lω̏			*/
	if ( updateFlag ) {

		/* p[^\		*/
		drawItem( mode ,1 );
		if ( updateFlag != 3 ) {

			/* OtXV			*/
			if ( updateFlag == 1 ) {
				g_drawBoxF( sys.gDrawMode ,ZX + 1 ,BY1 ,ZX + ( (BX2 - ZX) / 2 ) ,ZY - 1 ,RGB(0,0,0) );
				g_drawBoxF( sys.gDrawMode ,ZX + 1 ,ZY + 1 ,ZX + ( (BX2 - ZX) / 2 ) ,BY2 ,RGB(0,0,0) );
			} else {
				g_drawBoxF( sys.gDrawMode ,ZX + ( (BX2 - ZX) / 2 ) ,BY1 ,BX2 ,ZY - 1 ,RGB(0,0,0) );
				g_drawBoxF( sys.gDrawMode ,ZX + ( (BX2 - ZX) / 2 ) ,ZY + 1 ,BX2 ,BY2 ,RGB(0,0,0) );
			}
			drawGraph();

			/* DSPp[^ݒ	*/
			dspDisable();
			vsBassEmphasis( low_freq ,low_lv );
			vsHighPitchedSoundEmphasis( hi_freq ,hi_lv );
			if ( sys.playMode & PLAY_STS_DSP_BIT ) {
				dspEnable();
			}
		}
	}
}

/*****************************************************************************
*							Ot\
* Fvoid
* ߒlFvoid
*****************************************************************************/
static void drawGraph( void )
{
	uint8_t x1 = 0;
	uint8_t x2 = 0;
	uint8_t y = 0;
	uint16_t color;

	/* ቹ`					*/
	if ( low_freq && low_lv ) {
		x1 = ZX + ( low_freq * 2 ) + 2;
		x2 = x1 + 4;
		y = ZY - low_lv;
		g_drawLine( sys.gDrawMode ,ZX + 2 ,y ,x1 ,y ,RGB(0,255,255) );
		g_drawLine( sys.gDrawMode ,x1 ,y ,x2 ,ZY ,RGB(0,255,255) );
	}

	/* ` 1step = 1.5db		*/
	if ( hi_lv && hi_freq ) {
		x2 = BX2 - ( ( 15 - hi_freq ) * 2 ) - 4;
		x1 = x2 - 4;
		y = ZY - ( ( ( hi_lv * 15 ) + 5 ) / 10 );	/* 1.5dbXebvvZ	*/
		if ( hi_lv > 0 ) {
			color = RGB(0,255,255);
		} else {
			color = RGB(255,0,255);
		}
		g_drawLine( sys.gDrawMode ,x1 ,ZY ,x2 ,y ,color );
		g_drawLine( sys.gDrawMode ,x2 ,y ,BX2 - 1 ,y ,color );
	}

	/* `					*/
	g_drawBoxF( sys.gDrawMode ,BX1 + 19 ,ZY ,BX2 ,ZY ,RGB(255,255,255) );	/* _	*/
}

/*****************************************************************************
*								ACe\
* Fuint8_t index ACeԍ(0`7)
*       uint8_t sel  0:I 1:I
* ߒlFvoid
*****************************************************************************/
static void drawItem( uint8_t index ,uint8_t sel )
{
	char txt[16];
	char buf[16];
	uint8_t x ,y;
	uint8_t i;
	uint16_t bgColor;
	uint16_t fcColor;

	/* \Fݒ					*/	
	if ( index < 4 ) {
		if ( sel ) {
			bgColor = RGB(0,255,0);
			fcColor = RGB(0,64,0);
		} else {
			bgColor = RGB( 0,0,0 );
			fcColor = RGB(255,255,255);
		}
	} else {
		if ( sel ) {
			bgColor = RGB(255,150,0);
			fcColor = RGB(64,32,0);
		} else {
			bgColor = RGB( 0,0,0 );
			fcColor = RGB(255,150,0);
		}
	}

	/* \eLXg쐬				*/
	switch ( index ) {
		case 0:
			x = BX1;
			y = BY2 + 4;
			strcpy_P( txt ,PSTR("ቹg") );
			break;

		case 1:
			x = BX1;
			y = BY2 + 17;
			strcpy_P( txt ,PSTR("        ") );
			break;

		case 2:
			x = BX1;
			y = BY2 + 33;
			strcpy_P( txt ,PSTR("g") );
			break;

		case 3:
			x = BX1;
			y = BY2 + 46;
			strcpy_P( txt ,PSTR("        ") );
			break;

		case 4:
			x = BX1 + 74;
			y = BY2 + 4;
			sprintf_P( txt ,PSTR("  %2d0Hz") ,low_freq );
			break;

		case 5:
			x = BX1 + 74;
			y = BY2 + 17;
	
			if ( low_lv == 0 ) {
				strcpy_P( txt ,PSTR("    OFF") );
			} else {
				sprintf_P( buf ,PSTR("+%d.0db") ,low_lv );
				i = strlen( buf );
				memset( txt ,' ' ,7 );
				strcpy( &txt[ 7 - i ] ,buf );
			}
			break;

		case 6:
			x = BX1 + 74;
			y = BY2 + 33;
			sprintf_P( txt ,PSTR("%2d000Hz") ,hi_freq );
			break;

		case 7:
			x = BX1 + 74;
			y = BY2 + 46;
			if ( hi_lv == 0 ) {
				strcpy_P( buf ,PSTR("    OFF") );
			} else if ( hi_lv > 0 ) {
				sprintf_P( buf ,PSTR("+%d.%ddb") ,( hi_lv * 15 ) / 10 ,( hi_lv * 15 ) % 10 );
			} else {
				sprintf_P( buf ,PSTR("-%d.%ddb") ,-( hi_lv * 15 ) / 10 ,-( hi_lv * 15 ) % 10 );
			}
			i = strlen( buf );
			memset( txt ,' ' ,7 );
			strcpy( &txt[ 7 - i ] ,buf );

			break;

		default:
			return;
	}

	/* ACeeLXg\		*/
	g_puts( &sys.fnt1 ,x ,y ,txt ,sys.gDrawMode ,fcColor ,bgColor );
}
