/*###########################################################################
#                                                                           #
#                 		vCACeXg֌W@@@@@@@@@@@@@@#
#                                                                           #
###########################################################################*/
#define __PLAY_FILE_LIST_C__
#include "project.h"

/*****************************************************************************
*		w̃CfbNXACẽtpXt@C(8.3`)擾
* FPLAYLIST *list	vCXg\̂ւ̃|C^
*		uint8_t  index  CfbNXԍ(255 = JgACe)
*		char     *fname t@Ci[obt@( PLAY_LIST_PATH_LEGNTH )
* ߒlFuint8_t  0:OK
*				!0:CfbNXԍG[
*****************************************************************************/
uint8_t playList_getItemName( PLAYLIST *list ,uint8_t index ,char *fname )
{
	uint8_t ret = 1;

	fname[0] = '\0';
	if ( index == 0xff ) {					/* JgACe				*/
		index = list->index;
	}

	if ( index < list->count ) {
		uint16_t len = strlen( list->path );
		if ( len ) {
			memcpy( fname ,list->path ,len );
			fname[len++] = '/';
		}
		strcpy( &fname[len] ,list->items[ index ].fname );
		ret = 0;
	}

	return ( ret );
}

/*****************************************************************************
*					tpXt@CJgACeƂ
* FPLAYLIST *list	vCXg\̂ւ̃|C^
*		char     *fname tpX̃t@C
* ߒlFuint8_t         0:OK  !0:NG
*****************************************************************************/
uint8_t playList_fileItem( PLAYLIST *list ,char *fname )
{
	uint16_t i;
	FILINFO info;
	char *p;
	char key[14];

	/* 擪̃XbV`FbN				*/
	if ( *fname == '/' ) {
		fname++;
	}

	/* t@C`FbN					*/
	i = strlen( fname );
	if ( ( i == 0 ) || ( i > PLAY_LIST_PATH_LEGNTH ) ) {
		return ( 1 );
	}

	/* t@C݂邩`FbN			*/
	if ( f_stat( fname ,&info ) != FR_OK ) {
		return ( 2 );
	}

	/* t@C`FbN					*/
	if ( info.fattrib & ( AM_DIR | AM_HID | AM_SYS ) ) {
		return ( 3 );
	}

	/* t@C̑fBNg쐬	*/
	p = getFileName( fname );
	if ( p == NULL ) {
		return ( 4 );
	}
	strcpy( key ,p );

	if ( p == fname ) {
		list->path[0] = '\0';

	} else {
		i = ( (uint16_t)p - (uint16_t)fname ) - 1;
		memcpy( list->path ,fname ,i );
		list->path[i] = '\0';
	}

	/* fBNg̃ACe			*/
	if ( playList_loadDir( list ,list->path ) ) {
		return ( 5 );
	}

	/* Xgt@C			*/
	for ( i = 0 ;i < (uint16_t)list->count ;i++ ) {
		if ( strcasecmp( key ,list->items[i].fname ) == 0 ) {	/* v?					*/
			list->index = (uint8_t)i;							/* JgACeƂ	*/
			return ( 0 );
		}
	}

	return ( 7 );
}

/*****************************************************************************
* [gfBNg̐擪ŏɌt@CJgACeɂ
* FPLAYLIST *list	vCXg\̂ւ̃|C^
* ߒlFuint8_t  0:OK
*				!0:NG
*****************************************************************************/
uint8_t playList_findFastItem( PLAYLIST *list )
{
	uint8_t ret;

	ret = playList_loadDir( list ,"" );
	if ( ret ) {
		return ( 1 );
	}

	if ( list->count == 0 ) {
		return ( 2 );
	}

	list->index = 0xff;
	return ( playList_moveNext( list ,0 ) );
}

/*****************************************************************************
*					JgACe̎̃t@Cֈړ
* FPLAYLIST   *list vCXg\̂ւ̃|C^
*		REPET_TYPE repet s[g[h  REPET_NONE  ʏĐ
*						 				 REPET_FILE  ̃t@Cs[g
*						 				 REPET_DIRECTORY fBNgs[g
* ߒlFuint8_t	   0:OK
*				  !0:NG
*****************************************************************************/
uint8_t playList_moveNext( PLAYLIST *list ,REPET_TYPE repet )
{
	uint8_t endCount = 0;						/* Xg̍ŌɓB						*/
	uint8_t ret;

	if ( repet == REPET_FILE ) {
		return ( 0 );
	}

	while ( 1 ) {
		if ( ++list->index == list->count ) {	/* Xg̍ŌɒBꍇ͐efBNgֈړ	*/
			if ( repet == REPET_NONE ) {
				ret = playLIst_moveParents( list );
				if ( ret == 1 ) {
					if ( ++endCount >= 2 ) {
						break;
					}
					list->index = 0xff;
				} else if ( ret != 0 ) {
					break;
				}
			} else {
				list->index = 0xff;
			}
		} else {
			if ( list->items[list->index].atb == '0' ) {	/* ACet@C̏ꍇ͂ŏI	*/
				return ( 0 );
			} else {										/* ACefBNg̏ꍇ		*/
				if ( repet == REPET_NONE ) {
					ret = playList_moveChild( list );		/* fBNg̒Ɉړ				*/
					if ( ret ) {
						break;
					}
					list->index = 0xff;
				}
			}
		}
	}

	return ( 99 );
}

/*****************************************************************************
*					JgACȇÕt@Cֈړ
* FPLAYLIST   *list vCXg\̂ւ̃|C^
*		REPET_TYPE repet s[g[h  REPET_NONE  ʏĐ
*						 				 REPET_FILE  ̃t@Cs[g
*						 				 REPET_DIRECTORY fBNgs[g
* ߒlFuint8_t    0:OK
*				  !0:NG
*****************************************************************************/
uint8_t playList_moveBack( PLAYLIST *list ,REPET_TYPE repet )
{
	uint8_t endCount = 0;						/* Xg̍ŌɓB						*/
	uint8_t ret;

	if ( repet == REPET_FILE ) {
		return ( 0 );
	}

	while ( 1 ) {
		if ( --list->index == 0xff ) {			/* Xg̐擪ɒBꍇ͐efBNgֈړ		*/
			if ( repet == REPET_NONE ) {
				ret = playLIst_moveParents( list );
				if ( ret == 1 ) {
					if ( ++endCount >= 2 ) {
						break;
					}
					list->index = list->count;
				} else if ( ret != 0 ) {
					break;
				}
			} else {
				list->index = list->count;
			}
		} else {
			if ( list->items[list->index].atb == '0' ) {	/* ACet@C̏ꍇ͂ŏI	*/
				return ( 0 );
			} else {										/* ACefBNg̏ꍇ		*/
				if ( repet == REPET_NONE ) {
					ret = playList_moveChild( list );		/* fBNg̒Ɉړ				*/
					if ( ret ) {
						break;
					}
					list->index = list->count;
				}
			}
		}
	}

	return ( 99 );
}

/*****************************************************************************
* 							efBNgɈړ
* FPLAYLIST *list vCXg\̂ւ̃|C^
* ߒlFuint8_t 0 : OK
*				1 : efBNgï݂ʒu[gfBNgj
*			   99 : fBXNI/OG[
*****************************************************************************/
uint8_t playLIst_moveParents( PLAYLIST *list )
{
	char *p;
	char backFname[13];
	PLAY_LISTITEM *item;

	if ( list->path[0] == '\0' ) {
		return ( 1 );
	}

	/* Kw̃fBNgޔ		*/
	p = getFileName( list->path );
	strcpy( backFname ,p );

	/* efBNgpX쐬			*/
	if ( p == list->path ) {		/* efBNg̓[gfBNg?	*/
		*p = '\0';
	} else {						/* efBNg̓TufBNg?	*/
		*( p - 1 ) = '\0';
	}

	/* efBNg̃ACe	*/
	if ( playList_loadDir( list ,list->path ) != 0 ) {
		return ( 99 );
	}

	/* qfBNgƈvJgACeƂ	*/
	while ( list->index < list->count ) {
		item = &list->items[ list->index ];
		if ( ( item->atb == '1' ) && ( strcasecmp( item->fname ,backFname ) == 0 ) ) {
			return ( 0 );
		}
		list->index++;
	}

	return ( 99 );
}

/*****************************************************************************
* 							fBNg̒Ɉړ
* FPLAYLIST *list vCXg\̂ւ̃|C^
* ߒlFuint8_t 0 : OK
*				1 : JgACe
*				2 : JgACeTufBNgł͂Ȃ
*			   99 : fBXNI/OG[
*****************************************************************************/
uint8_t playList_moveChild( PLAYLIST *list )
{
	uint16_t pathLength;

	if ( list->index >= list->count ) {
		return ( 1 );
	}

	if ( list->items[list->index].atb != '1' ) {
		return ( 2 );
	}

	/* pX								*/
	pathLength = strlen( list->path );
	if ( list->path[0] != '\0' ) {
		list->path[ pathLength++ ] = '/';
	}
	strcpy( &list->path[ pathLength ] ,list->items[list->index].fname );

	/* fBNg̃ACe		*/
	if ( playList_loadDir( list ,list->path ) != 0 ) {
		return ( 99 );
	}

	return ( 0 );
}

/****************************************************************************
*  					wfBNg̃vCXg쐬
* FPLAYLIST *list     vCXg\̂ւ̃|C^
*		char     *pathName fBNgpX
* ߒlFuint8_t        0:OK !0:NG
*
* pX̐擪ƍŌ '/' ͕tȂB[gfBNg "" w
*****************************************************************************/
uint8_t playList_loadDir( PLAYLIST *list ,char *pathName )
{
	/* ϐ錾										*/
	uint16_t h ,i ,j;
	DIR dir;
	PLAY_FILE_TYPE type;
	FILINFO ffInfo;
	PLAY_LISTITEM temp;
	PLAY_LISTITEM *item1;
	PLAY_LISTITEM *item2;

	/* vCXgp[^	*/
	list->count = 0;							/* ACe				*/
	list->index = 0;							/* CfbNXԍ			*/

	i = strlen( pathName );
	if ( i > ( PLAY_LIST_PATH_LEGNTH - 15 ) ) {	/* pXmF			*/
		return ( 1 );
	}

	if ( list->path != pathName ) {
		strcpy( list->path ,pathName );
	}

	if ( f_opendir( &dir ,list->path ) != FR_OK ) {
		return ( 2 );
	}

	while ( list->count < PLAY_LIST_ITEM_MAX ) {

		/* fBNgGgo		*/
		if ( f_readdir( &dir ,&ffInfo ) != FR_OK ) {
			return ( 3 );
		}

		if ( ffInfo.fname[0] == '\0' ) {
			break;
		}

		if ( ( ffInfo.fname[0] == '.' ) || ( ffInfo.fattrib & ( AM_HID | AM_SYS ) ) ) {
			continue;
		}

		item1 = &list->items[ list->count ];
		if ( ffInfo.fattrib & AM_DIR ) {
			item1->atb= '1';

		} else {
			list->path[ i ] = '/';
			strcpy( &list->path[ i + 1 ] ,ffInfo.fname );	/* gq`FbN	*/
			type = getPlayFileType( list->path );
			list->path[ i ] = '\0';
			if ( type == F_OTHER ) {
				continue;
			}
			item1->atb= '0';
		}

		/* ACeo^								*/
		strcpy( item1->fname ,ffInfo.fname );
		list->count++;
	}

	/* ACe\[giVF\[gj				*/
	for ( h = 1 ;h < (uint16_t)list->count ;h = ( h * 3 ) + 1 );
	do {
		for ( i = h ;i < (uint16_t)list->count ;i++ ) {
			for ( j = i ;j >= h ;j -= h ) {
				item1 = &list->items[ j     ];
				item2 = &list->items[ j - h ];
				if ( strcasecmp( (char *)&item1->atb ,(char *)&item2->atb ) >= 0 ) {
					break;
				}
				memcpy( &temp ,item1 ,sizeof(PLAY_LISTITEM) );
				memcpy( item1 ,item2 ,sizeof(PLAY_LISTITEM) );
				memcpy( item2 ,&temp ,sizeof(PLAY_LISTITEM) );
			}
		}
		h /= 3;
	} while ( h );

	return ( 0 );
}
