/*###########################################################################
#                                                                           #
#          	LCDW[uZY-FGD1442701V1v䃂W[					#
#                                                                           #
# [hf[^͏ʁEʂ̏Ԃŏo͂邱								#
# AVR̃oXɒ CS0=A15 / CD = A13	RD/WR/DATA						#
# obNCgLEDPB7Ő䂷(Lowœ_/Hiŏ)						#
# PB7Timer0PWMŋPxύXł									#
#                                                                           #
# _̕`^`̕`^̕`^ȒPASCII\݂̂T|[g	#
#                                                                           #
###########################################################################*/
#define __ZY_FGD1442701V1_C__
#include <avr/io.h>
#include <avr/pgmspace.h>
#include <util/delay.h>
#include "zy_fgd1442701v1.h"

#define KANA 0						/* tHgɃJi܂ނǂ		*/

/* EGCg}N	*/
#define WAIT_MS(t) { uint16_t i = (uint16_t)(t); while ( i-- ) { _delay_ms( 1 ); } }

/* LCD R}h`					*/
#define LCD_SWRESET		0x01
#define LCD_RDDID		0x04
#define LCD_RDDST		0x09
#define LCD_RDDPM		0x0a
#define LCD_RDDMADCTL	0x0b
#define LCD_RDDCOLMOD	0x0c
#define LCD_RDDIM		0x0d
#define LCD_RDDSM		0x0e
#define LCD_SLPIN		0x10
#define LCD_SLPOUT		0x11
#define LCD_PTLON		0x12
#define LCD_NORON		0x13
#define LCD_INVOFF		0x20
#define LCD_INVON		0x21
#define LCD_GAMSET		0x26
#define LCD_DISPOFF		0x28
#define LCD_DISPON		0x29
#define LCD_CASET		0x2a
#define LCD_RASET		0x2b
#define LCD_RAMWR		0x2c
#define LCD_RAMRD		0x2e
#define LCD_PTLAR		0x30
#define LCD_TEOFF		0x34
#define LCD_TEON		0x35
#define LCD_MADCTL		0x36
#define LCD_IDMOFF		0x38
#define LCD_IDMON		0x39
#define LCD_COLMOD		0x3a
#define LCD_RDID1		0xda
#define LCD_RDID2		0xdb
#define LCD_RDID3		0xdc
#define LCD_FRMCTR1		0xb1
#define LCD_FRMCTR2		0xb2
#define LCD_FRMCTR3		0xb3
#define LCD_INVCTR		0xb4
#define LCD_DISSET5		0xb6
#define LCD_PWCTR1		0xc0
#define LCD_PWCTR2		0xc1
#define LCD_PWCTR3		0xc2
#define LCD_PWCTR4		0xc3
#define LCD_PWCTR5		0xc4
#define LCD_VMCTR1		0xc5
#define LCD_VMOFCTR		0xc7
#define LCD_WRID2		0xd1
#define LCD_WRID3		0xd2
#define LCD_PWCTR6		0xfc
#define LCD_NVCTR1		0xd9
#define LCD_NVCTR2		0xde
#define LCD_NVCTR3		0xdf
#define LCD_GAMCTRP1	0xe0
#define LCD_GAMCTRN1	0xe1
#define LCD_EXTCTRL		0xf0
#define LCD_VCOM4L		0xff

/* 5 x c7 ptHge[u	*/
/* 0x20 ` 0x8a / 0xa1 ` 0xdf		*/
static const prog_uint8_t font[] = {
		0x00 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00 ,	/* 0x20 :  	*/
		0x20 ,0x20 ,0x20 ,0x20 ,0x00 ,0x00 ,0x20 ,	/* 0x21 : !	*/
		0x50 ,0x50 ,0x50 ,0x00 ,0x00 ,0x00 ,0x00 ,	/* 0x22 : "	*/
		0x50 ,0x50 ,0xf8 ,0x50 ,0xf8 ,0x50 ,0x50 ,	/* 0x23 : #	*/
		0x20 ,0x78 ,0xa0 ,0x70 ,0x28 ,0xf0 ,0x20 ,	/* 0x24 : $	*/
		0xc0 ,0xc8 ,0x10 ,0x20 ,0x40 ,0x98 ,0x18 ,	/* 0x25 : %	*/
		0x60 ,0x90 ,0xa0 ,0x40 ,0xa8 ,0x90 ,0x68 ,	/* 0x26 : &	*/
		0x60 ,0x20 ,0x40 ,0x00 ,0x00 ,0x00 ,0x00 ,	/* 0x27 : '	*/
		0x10 ,0x20 ,0x40 ,0x40 ,0x40 ,0x20 ,0x10 ,	/* 0x28 : (	*/
		0x40 ,0x20 ,0x10 ,0x10 ,0x10 ,0x20 ,0x40 ,	/* 0x29 : )	*/
		0x00 ,0x20 ,0xa8 ,0x70 ,0xa8 ,0x20 ,0x00 ,	/* 0x2a : *	*/
		0x00 ,0x20 ,0x20 ,0xf8 ,0x20 ,0x20 ,0x00 ,	/* 0x2b : +	*/
		0x00 ,0x00 ,0x00 ,0x00 ,0x60 ,0x20 ,0x40 ,	/* 0x2c : ,	*/
		0x00 ,0x00 ,0x00 ,0xf8 ,0x00 ,0x00 ,0x00 ,	/* 0x2d : -	*/
		0x00 ,0x00 ,0x00 ,0x00 ,0x00 ,0x60 ,0x60 ,	/* 0x2e : .	*/
		0x00 ,0x08 ,0x10 ,0x20 ,0x40 ,0x80 ,0x00 ,	/* 0x2f : /	*/
		0x70 ,0x88 ,0x98 ,0xa8 ,0xc8 ,0x88 ,0x70 ,	/* 0x30 : 0	*/
		0x20 ,0x60 ,0x20 ,0x20 ,0x20 ,0x20 ,0x70 ,	/* 0x31 : 1	*/
		0x70 ,0x88 ,0x08 ,0x10 ,0x20 ,0x40 ,0xf8 ,	/* 0x32 : 2	*/
		0xf8 ,0x10 ,0x20 ,0x10 ,0x08 ,0x88 ,0x70 ,	/* 0x33 : 3	*/
		0x10 ,0x30 ,0x50 ,0x90 ,0xf8 ,0x10 ,0x10 ,	/* 0x34 : 4	*/
		0xf8 ,0x80 ,0xf0 ,0x08 ,0x08 ,0x88 ,0x70 ,	/* 0x35 : 5	*/
		0x30 ,0x40 ,0x80 ,0xf0 ,0x88 ,0x88 ,0x70 ,	/* 0x36 : 6	*/
		0xf8 ,0x08 ,0x10 ,0x20 ,0x40 ,0x40 ,0x40 ,	/* 0x37 : 7	*/
		0x70 ,0x88 ,0x88 ,0x70 ,0x88 ,0x88 ,0x70 ,	/* 0x38 : 8	*/
		0x70 ,0x88 ,0x88 ,0x78 ,0x08 ,0x10 ,0x60 ,	/* 0x39 : 9	*/
		0x00 ,0x60 ,0x60 ,0x00 ,0x60 ,0x60 ,0x00 ,	/* 0x3a : :	*/
		0x00 ,0x60 ,0x60 ,0x00 ,0x60 ,0x20 ,0x40 ,	/* 0x3b : ;	*/
		0x10 ,0x20 ,0x40 ,0x80 ,0x40 ,0x20 ,0x10 ,	/* 0x3c : <	*/
		0x00 ,0x00 ,0xf8 ,0x00 ,0xf8 ,0x00 ,0x00 ,	/* 0x3d : =	*/
		0x40 ,0x20 ,0x10 ,0x08 ,0x10 ,0x20 ,0x40 ,	/* 0x3e : >	*/
		0x70 ,0x88 ,0x08 ,0x10 ,0x20 ,0x00 ,0x20 ,	/* 0x3f : ?	*/
		0x70 ,0x88 ,0x08 ,0x68 ,0xa8 ,0xa8 ,0x70 ,	/* 0x40 : @	*/
		0x70 ,0x88 ,0x88 ,0x88 ,0xf8 ,0x88 ,0x88 ,	/* 0x41 : A	*/
		0xf0 ,0x88 ,0x88 ,0xf0 ,0x88 ,0x88 ,0xf0 ,	/* 0x42 : B	*/
		0x70 ,0x88 ,0x80 ,0x80 ,0x80 ,0x88 ,0x70 ,	/* 0x43 : C	*/
		0xe0 ,0x90 ,0x88 ,0x88 ,0x88 ,0x90 ,0xe0 ,	/* 0x44 : D	*/
		0xf8 ,0x80 ,0x80 ,0xf0 ,0x80 ,0x80 ,0xf8 ,	/* 0x45 : E	*/
		0xf8 ,0x80 ,0x80 ,0xf0 ,0x80 ,0x80 ,0x80 ,	/* 0x46 : F	*/
		0x70 ,0x88 ,0x80 ,0xb8 ,0x88 ,0x88 ,0x78 ,	/* 0x47 : G	*/
		0x88 ,0x88 ,0x88 ,0xf8 ,0x88 ,0x88 ,0x88 ,	/* 0x48 : H	*/
		0x70 ,0x20 ,0x20 ,0x20 ,0x20 ,0x20 ,0x70 ,	/* 0x49 : I	*/
		0x38 ,0x10 ,0x10 ,0x10 ,0x10 ,0x90 ,0x60 ,	/* 0x4a : J	*/
		0x88 ,0x90 ,0xa0 ,0xc0 ,0xa0 ,0x90 ,0x88 ,	/* 0x4b : K	*/
		0x80 ,0x80 ,0x80 ,0x80 ,0x80 ,0x80 ,0xf8 ,	/* 0x4c : L	*/
		0x88 ,0xd8 ,0xa8 ,0xa8 ,0x88 ,0x88 ,0x88 ,	/* 0x4d : M	*/
		0x88 ,0x88 ,0xc8 ,0xa8 ,0x98 ,0x88 ,0x88 ,	/* 0x4e : N	*/
		0x70 ,0x88 ,0x88 ,0x88 ,0x88 ,0x88 ,0x70 ,	/* 0x4f : O	*/
		0xf0 ,0x88 ,0x88 ,0xf0 ,0x80 ,0x80 ,0x80 ,	/* 0x50 : P	*/
		0x70 ,0x88 ,0x88 ,0x88 ,0xa8 ,0x90 ,0x68 ,	/* 0x51 : Q	*/
		0xf0 ,0x88 ,0x88 ,0xf0 ,0xa0 ,0x90 ,0x88 ,	/* 0x52 : R	*/
		0x78 ,0x80 ,0x80 ,0x70 ,0x08 ,0x08 ,0xf0 ,	/* 0x53 : S	*/
		0xf8 ,0x20 ,0x20 ,0x20 ,0x20 ,0x20 ,0x20 ,	/* 0x54 : T	*/
		0x88 ,0x88 ,0x88 ,0x88 ,0x88 ,0x88 ,0x70 ,	/* 0x55 : U	*/
		0x88 ,0x88 ,0x88 ,0x88 ,0x88 ,0x50 ,0x20 ,	/* 0x56 : V	*/
		0x88 ,0x88 ,0x88 ,0xa8 ,0xa8 ,0xa8 ,0x50 ,	/* 0x57 : W	*/
		0x88 ,0x88 ,0x50 ,0x20 ,0x50 ,0x88 ,0x88 ,	/* 0x58 : X	*/
		0x88 ,0x88 ,0x88 ,0x50 ,0x20 ,0x20 ,0x20 ,	/* 0x59 : Y	*/
		0xf8 ,0x08 ,0x10 ,0x20 ,0x40 ,0x80 ,0xf8 ,	/* 0x5a : Z	*/
		0x70 ,0x40 ,0x40 ,0x40 ,0x40 ,0x40 ,0x70 ,	/* 0x5b : [	*/
		0x00 ,0x80 ,0x40 ,0x20 ,0x10 ,0x08 ,0x00 ,	/* 0x5c : \	*/
		0x70 ,0x10 ,0x10 ,0x10 ,0x10 ,0x10 ,0x70 ,	/* 0x5d : ]	*/
		0x20 ,0x50 ,0x88 ,0x00 ,0x00 ,0x00 ,0x00 ,	/* 0x5e : ^	*/
		0x00 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00 ,0xf8 ,	/* 0x5f : _	*/
		0x40 ,0x20 ,0x10 ,0x00 ,0x00 ,0x00 ,0x00 ,	/* 0x60 : `	*/
		0x00 ,0x00 ,0x70 ,0x08 ,0x78 ,0x88 ,0x78 ,	/* 0x61 : a	*/
		0x80 ,0x80 ,0xb0 ,0xc8 ,0x88 ,0x88 ,0xf0 ,	/* 0x62 : b	*/
		0x00 ,0x00 ,0x70 ,0x80 ,0x80 ,0x88 ,0x70 ,	/* 0x63 : c	*/
		0x08 ,0x08 ,0x68 ,0x98 ,0x88 ,0x88 ,0x78 ,	/* 0x64 : d	*/
		0x00 ,0x00 ,0x70 ,0x88 ,0xf8 ,0x80 ,0x70 ,	/* 0x65 : e	*/
		0x30 ,0x48 ,0x40 ,0xe0 ,0x40 ,0x40 ,0x40 ,	/* 0x66 : f	*/
		0x00 ,0x78 ,0x88 ,0x88 ,0x78 ,0x08 ,0x70 ,	/* 0x67 : g	*/
		0x80 ,0x80 ,0xb0 ,0xc8 ,0x88 ,0x88 ,0x88 ,	/* 0x68 : h	*/
		0x20 ,0x00 ,0x60 ,0x20 ,0x20 ,0x20 ,0x70 ,	/* 0x69 : i	*/
		0x10 ,0x00 ,0x30 ,0x10 ,0x10 ,0x90 ,0x60 ,	/* 0x6a : j	*/
		0x80 ,0x80 ,0x90 ,0xa0 ,0xc0 ,0xa0 ,0x90 ,	/* 0x6b : k	*/
		0x60 ,0x20 ,0x20 ,0x20 ,0x20 ,0x20 ,0x70 ,	/* 0x6c : l	*/
		0x00 ,0x00 ,0xd0 ,0xa8 ,0xa8 ,0x88 ,0x88 ,	/* 0x6d : m	*/
		0x00 ,0x00 ,0xb0 ,0xc8 ,0x88 ,0x88 ,0x88 ,	/* 0x6e : n	*/
		0x00 ,0x00 ,0x70 ,0x88 ,0x88 ,0x88 ,0x70 ,	/* 0x6f : o	*/
		0x00 ,0x00 ,0xf0 ,0x88 ,0xf0 ,0x80 ,0x80 ,	/* 0x70 : p	*/
		0x00 ,0x00 ,0x68 ,0x98 ,0x78 ,0x08 ,0x08 ,	/* 0x71 : q	*/
		0x00 ,0x00 ,0xb0 ,0xc8 ,0x80 ,0x80 ,0x80 ,	/* 0x72 : r	*/
		0x00 ,0x00 ,0x70 ,0x80 ,0x70 ,0x08 ,0xf0 ,	/* 0x73 : s	*/
		0x40 ,0x40 ,0xe0 ,0x40 ,0x40 ,0x48 ,0x30 ,	/* 0x74 : t	*/
		0x00 ,0x00 ,0x88 ,0x88 ,0x88 ,0x98 ,0x68 ,	/* 0x75 : u	*/
		0x00 ,0x00 ,0x88 ,0x88 ,0x88 ,0x50 ,0x20 ,	/* 0x76 : v	*/
		0x00 ,0x00 ,0x88 ,0x88 ,0xa8 ,0xa8 ,0x50 ,	/* 0x77 : w	*/
		0x00 ,0x00 ,0x88 ,0x50 ,0x20 ,0x50 ,0x88 ,	/* 0x78 : x	*/
		0x00 ,0x00 ,0x88 ,0x88 ,0x78 ,0x08 ,0x70 ,	/* 0x79 : y	*/
		0x00 ,0x00 ,0xf8 ,0x10 ,0x20 ,0x40 ,0xf8 ,	/* 0x7a : z	*/
		0x10 ,0x20 ,0x20 ,0x40 ,0x20 ,0x20 ,0x10 ,	/* 0x7b : {	*/
		0x20 ,0x20 ,0x20 ,0x20 ,0x20 ,0x20 ,0x20 ,	/* 0x7c : |	*/
		0x40 ,0x20 ,0x20 ,0x10 ,0x20 ,0x20 ,0x40 ,	/* 0x7d : }	*/
		0x00 ,0x20 ,0x10 ,0xf8 ,0x10 ,0x20 ,0x00 ,	/* 0x7e : ~	*/
		0x00 ,0x20 ,0x40 ,0xf8 ,0x40 ,0x20 ,0x00 ,	/* 0x7f : 	*/
#if (KANA != 0)
		0x20 ,0x20 ,0x20 ,0x38 ,0x00 ,0x00 ,0x00 ,	/* 0x80 : 	*/
		0x20 ,0x20 ,0x20 ,0xe0 ,0x00 ,0x00 ,0x00 ,	/* 0x81 : 	*/
		0x00 ,0x70 ,0x88 ,0x88 ,0x50 ,0xd8 ,0x00 ,	/* 0x82 : 	*/
		0x00 ,0x00 ,0xf8 ,0x50 ,0x50 ,0x50 ,0x98 ,	/* 0x83 : 	*/
		0xf8 ,0x80 ,0x40 ,0x20 ,0x40 ,0x80 ,0xf8 ,	/* 0x84 : 	*/
		0x00 ,0x08 ,0xf0 ,0x20 ,0xf8 ,0x20 ,0x20 ,	/* 0x85 : 	*/
		0x00 ,0x00 ,0xf8 ,0x40 ,0x78 ,0x48 ,0x88 ,	/* 0x86 : 	*/
		0x00 ,0x00 ,0xf8 ,0xa8 ,0xf8 ,0x88 ,0x88 ,	/* 0x87 : 	*/
		0x00 ,0x00 ,0x20 ,0x00 ,0xf8 ,0x00 ,0x20 ,	/* 0x88 : 	*/
		0xf8 ,0xf8 ,0xf8 ,0xf8 ,0xf8 ,0xf8 ,0xf8 ,	/* 0x89 : 	*/
		0xf8 ,0xf8 ,0xf8 ,0xf8 ,0x00 ,0x00 ,0x00 ,	/* 0x8a : 	*/
		0x00 ,0x00 ,0x00 ,0x00 ,0xe0 ,0xa0 ,0xe0 ,	/* 0xa1 : 	*/
		0x38 ,0x20 ,0x20 ,0x20 ,0x00 ,0x00 ,0x00 ,	/* 0xa2 : 	*/
		0x00 ,0x00 ,0x00 ,0x20 ,0x20 ,0x20 ,0xe0 ,	/* 0xa3 : 	*/
		0x00 ,0x00 ,0x00 ,0x00 ,0x80 ,0x40 ,0x20 ,	/* 0xa4 : 	*/
		0x00 ,0x00 ,0x00 ,0x60 ,0x60 ,0x00 ,0x00 ,	/* 0xa5 : 	*/
		0x00 ,0xf8 ,0x08 ,0xf8 ,0x08 ,0x10 ,0x20 ,	/* 0xa6 : 	*/
		0x00 ,0x00 ,0xf8 ,0x08 ,0x30 ,0x60 ,0x00 ,	/* 0xa7 : 	*/
		0x00 ,0x00 ,0x10 ,0x20 ,0x60 ,0xa0 ,0x20 ,	/* 0xa8 : 	*/
		0x00 ,0x00 ,0x20 ,0xf8 ,0x88 ,0x08 ,0x30 ,	/* 0xa9 : 	*/
		0x00 ,0x00 ,0x00 ,0xf8 ,0x20 ,0x20 ,0xf8 ,	/* 0xaa : 	*/
		0x00 ,0x00 ,0x10 ,0xf8 ,0x30 ,0x50 ,0x90 ,	/* 0xab : 	*/
		0x00 ,0x00 ,0x40 ,0xf8 ,0x48 ,0x50 ,0x40 ,	/* 0xac : 	*/
		0x00 ,0x00 ,0x00 ,0x70 ,0x10 ,0x10 ,0xf8 ,	/* 0xad : 	*/
		0x00 ,0x00 ,0xf0 ,0x10 ,0xf0 ,0x10 ,0xf0 ,	/* 0xae : 	*/
		0x00 ,0x00 ,0x00 ,0xa8 ,0xa8 ,0x08 ,0x30 ,	/* 0xaf : 	*/
		0x00 ,0x00 ,0x00 ,0xf8 ,0x00 ,0x00 ,0x00 ,	/* 0xb0 : 	*/
		0xf8 ,0x08 ,0x28 ,0x30 ,0x20 ,0x20 ,0x40 ,	/* 0xb1 : 	*/
		0x08 ,0x10 ,0x20 ,0x20 ,0x60 ,0xa0 ,0x20 ,	/* 0xb2 : 	*/
		0x20 ,0xf8 ,0x88 ,0x88 ,0x08 ,0x10 ,0x20 ,	/* 0xb3 : 	*/
		0x00 ,0xf8 ,0x20 ,0x20 ,0x20 ,0x20 ,0xf8 ,	/* 0xb4 : 	*/
		0x10 ,0xf8 ,0x10 ,0x30 ,0x50 ,0x90 ,0x10 ,	/* 0xb5 : 	*/
		0x40 ,0xf8 ,0x48 ,0x48 ,0x48 ,0x48 ,0x90 ,	/* 0xb6 : 	*/
		0x20 ,0xf8 ,0x20 ,0xf8 ,0x20 ,0x20 ,0x20 ,	/* 0xb7 : 	*/
		0x00 ,0x78 ,0x48 ,0x88 ,0x08 ,0x10 ,0x60 ,	/* 0xb8 : 	*/
		0x40 ,0x70 ,0x98 ,0x10 ,0x10 ,0x10 ,0x20 ,	/* 0xb9 : 	*/
		0x00 ,0xf8 ,0x08 ,0x08 ,0x08 ,0x08 ,0xf8 ,	/* 0xba : 	*/
		0x50 ,0xf8 ,0x50 ,0x50 ,0x10 ,0x20 ,0x40 ,	/* 0xbb : 	*/
		0x00 ,0xc0 ,0x08 ,0xc8 ,0x08 ,0x10 ,0xe0 ,	/* 0xbc : 	*/
		0x00 ,0xf8 ,0x08 ,0x10 ,0x20 ,0x50 ,0x88 ,	/* 0xbd : 	*/
		0x40 ,0xf8 ,0x48 ,0x50 ,0x40 ,0x40 ,0x38 ,	/* 0xbe : 	*/
		0x00 ,0x88 ,0x88 ,0x48 ,0x08 ,0x10 ,0x60 ,	/* 0xbf : 	*/
		0x00 ,0x78 ,0x48 ,0xa8 ,0x18 ,0x10 ,0x60 ,	/* 0xc0 : 	*/
		0x10 ,0xe0 ,0x20 ,0xf8 ,0x20 ,0x20 ,0x40 ,	/* 0xc1 : 	*/
		0x00 ,0xa8 ,0xa8 ,0xa8 ,0x08 ,0x10 ,0x20 ,	/* 0xc2 : 	*/
		0x70 ,0x00 ,0xf8 ,0x20 ,0x20 ,0x20 ,0x40 ,	/* 0xc3 : 	*/
		0x40 ,0x40 ,0x40 ,0x60 ,0x50 ,0x40 ,0x40 ,	/* 0xc4 : 	*/
		0x20 ,0x20 ,0xf8 ,0x20 ,0x20 ,0x40 ,0x80 ,	/* 0xc5 : 	*/
		0x00 ,0x70 ,0x00 ,0x00 ,0x00 ,0x00 ,0xf8 ,	/* 0xc6 : 	*/
		0x00 ,0xf8 ,0x08 ,0x50 ,0x20 ,0x50 ,0x80 ,	/* 0xc7 : 	*/
		0x20 ,0xf8 ,0x10 ,0x20 ,0x70 ,0xa8 ,0x20 ,	/* 0xc8 : 	*/
		0x10 ,0x10 ,0x10 ,0x10 ,0x10 ,0x20 ,0x40 ,	/* 0xc9 : 	*/
		0x00 ,0x20 ,0x10 ,0x88 ,0x88 ,0x88 ,0x88 ,	/* 0xca : 	*/
		0x80 ,0x80 ,0xf8 ,0x80 ,0x80 ,0x80 ,0x78 ,	/* 0xcb : 	*/
		0x00 ,0xf8 ,0x08 ,0x08 ,0x08 ,0x10 ,0x60 ,	/* 0xcc : 	*/
		0x00 ,0x40 ,0xa0 ,0x10 ,0x08 ,0x08 ,0x00 ,	/* 0xcd : 	*/
		0x20 ,0xf8 ,0x20 ,0x20 ,0xa8 ,0xa8 ,0x20 ,	/* 0xce : 	*/
		0x00 ,0xf8 ,0x08 ,0x08 ,0x50 ,0x20 ,0x10 ,	/* 0xcf : 	*/
		0x00 ,0x70 ,0x00 ,0x70 ,0x00 ,0x70 ,0x08 ,	/* 0xd0 : 	*/
		0x00 ,0x20 ,0x40 ,0x80 ,0x88 ,0xf8 ,0x08 ,	/* 0xd1 : 	*/
		0x00 ,0x08 ,0x08 ,0x50 ,0x20 ,0x50 ,0x80 ,	/* 0xd2 : 	*/
		0x00 ,0xf8 ,0x40 ,0xf8 ,0x40 ,0x40 ,0x38 ,	/* 0xd3 : 	*/
		0x40 ,0x40 ,0xf8 ,0x48 ,0x50 ,0x40 ,0x40 ,	/* 0xd4 : 	*/
		0x00 ,0x70 ,0x10 ,0x10 ,0x10 ,0x10 ,0xf8 ,	/* 0xd5 : 	*/
		0x00 ,0xf8 ,0x08 ,0xf8 ,0x08 ,0x08 ,0xf8 ,	/* 0xd6 : 	*/
		0x70 ,0x00 ,0xf8 ,0x08 ,0x08 ,0x10 ,0x20 ,	/* 0xd7 : 	*/
		0x90 ,0x90 ,0x90 ,0x90 ,0x10 ,0x20 ,0x40 ,	/* 0xd8 : 	*/
		0x00 ,0x20 ,0xa0 ,0xa0 ,0xa8 ,0xa8 ,0xa0 ,	/* 0xd9 : 	*/
		0x00 ,0x80 ,0x80 ,0x88 ,0x90 ,0xa0 ,0xc0 ,	/* 0xda : 	*/
		0x00 ,0xf8 ,0x88 ,0x88 ,0x88 ,0x88 ,0xf8 ,	/* 0xdb : 	*/
		0x00 ,0xf8 ,0x88 ,0x88 ,0x08 ,0x10 ,0x20 ,	/* 0xdc : 	*/
		0x00 ,0xc0 ,0x00 ,0x08 ,0x08 ,0x10 ,0xe0 ,	/* 0xdd : 	*/
		0x20 ,0x90 ,0x40 ,0x00 ,0x00 ,0x00 ,0x00 ,	/* 0xde : 	*/
		0xe0 ,0xa0 ,0xe0 ,0x00 ,0x00 ,0x00 ,0x00 ,	/* 0xdf : 	*/
#endif
};

/*****************************************************************************
*									LCD
* Fvoid
* ߒlFvoid
*****************************************************************************/
void lcdInit( void )
{
	/* LCD̎			*/
	static const prog_uint8_t initPara[] = {
		/* Soft Reset																	*/
		  LCD_SWRESET ,0
		, 0 ,50					/* WAIT 50msec											*/

		/* Sleep Out																	*/
 		, LCD_SLPOUT ,0
		, 0 ,200				/* WAIT 200msec											*/

		/* VCOM4 Level																	*/
		, LCD_VCOM4L ,3
		, 0x40 ,0x03 ,0x1a		/* TC2=4,TC1=0,TC3=3 clock delay						*/

		/* NVCTR1																		*/
		, LCD_NVCTR1 ,1
		, 0x60

		/* VMOFCTR																		*/
		, LCD_VMOFCTR ,1
		, 0x90
		, 0 ,200				/* WAIT 200msec											*/

		/* Frame Rate Control(In normal mode/ Full colors) 								*/
		/* Frame rate= f_osc/((RTNA + 20)*(LINE+FPA+BPA))								*/
		, LCD_FRMCTR1 ,3
		, 0x04 ,0x25 ,0x18		/* RTNA = 0x04 / FPA = 0x25 / BPA = 0x18				*/

		/* Frame Rate Control (In Idle mode/ 8-colors)									*/
		, LCD_FRMCTR2 ,3
		, 0x04 ,0x25 ,0x18

		/* Frame Rate Control (In Partial mode/ full colors)							*/
		, LCD_FRMCTR3 ,6
		, 0x04 ,0x25 ,0x18		/* 1st parameter to 3rd parameter are used in line inversion mode.	*/
		, 0x04 ,0x25 ,0x18		/* 4th parameter to 6th parameter are used in frame inversion mode.	*/

		/* Display Inversion Control(0:line inversion, 1:frame inversion)				*/
		, LCD_INVCTR ,1
		, 0x03					/* [3:0] in full colors normal mode, in idle mode, in full colors partial mode (Partial mode on / Idle mode off) */

		/* Display Function set 5														*/
		, LCD_DISSET5 ,2
		, 0x15 ,0x02			/* NO=1,SDT=1,EQ=1 (default) / PTG=0,PT=2				*/

		/* POWER CONTROL 1 GVDD & AVDD													*/
		, LCD_PWCTR1 ,2
		, 0x02 ,0x70			/* 4.7V (default) / 1.0uA (default)						*/

		/* POWER CONTROL 2 VGHH & VCLL													*/
		, LCD_PWCTR2 ,1
		, 0x07e					/* 14.7V, -12.25V										*/

		/* POWER CONTROL 3 (in Normal mode/ Full colors)								*/
		, LCD_PWCTR3 ,2			/* POWER CONTROL 3 (in Normal mode/ Full colors)		*/
		, 0x01 ,0x01			/* default												*/

		/* POWER CONTROL 4 (in Idle mode/ 8-colors)										*/
		, LCD_PWCTR4 ,2
		, 0x02 ,0x07			/* default												*/

		/* POWER CONTROL 5 (in Partial mode/ full-colors)								*/
		, LCD_PWCTR5 ,2			/* POWER CONTROL 5 (in Partial mode/ full-colors)		*/
		, 0x02 ,0x04			/* default												*/

		/* POWER CONTROL 6 (in Partial mode + Idle mode)								*/
		, LCD_PWCTR6 ,2			/* POWER CONTROL 6 (in Partial mode + Idle mode)		*/
		, 0x11 ,0x17			/* 0x1115(default) -> 0x1117 fault)						*/

		/* VCOMH & VCOM																	*/
		, LCD_VMCTR1 ,2			/* VCOMH & VCOML										*/
		, 0x3c					/* default(0x3c:4.00V)									*/
		, 0x4d 					/* default(0x3a:-1.050V) -> 0x4f:-0.525V				*/

		/* Memory data access control													*/
		, LCD_MADCTL ,1
		, LCD_MADCTL_PARA		/* _^|C^iݕݒ							*/

		/* Interface pixel format	*/
		, LCD_COLMOD ,1
		, LCD_COLMOD_16BIT		/* 16bitJ[[h									*/
		
		/* GAMMA +polarity		*/
		, LCD_GAMCTRP1 ,16
		, 0x06 ,0x0e ,0x05 ,0x20 ,0x27 ,0x23 ,0x1c ,0x21 ,0x20 ,0x1c ,0x26 ,0x2f ,0x00 ,0x03 ,0x00 ,0x24

		/* GAMMA -polarity		*/
		, LCD_GAMCTRN1 ,16
		, 0x06 ,0x10 ,0x05 ,0x21 ,0x27 ,0x22 ,0x1c ,0x21 ,0x1f ,0x1d ,0x27 ,0x2f ,0x05 ,0x03 ,0x00 ,0x3f
	};

	/* obNCgOFF			*/
	lcdSetBrightness( 0 );

	/* n[hEGAZbg		*/
	LCD_DISABLE_RESET();
	WAIT_MS( 100 );
	LCD_ENABLE_RESET();
	WAIT_MS( 100 );
	LCD_DISABLE_RESET();
	WAIT_MS( 120 );

	/* p[^ݒ		*/
	uint16_t i = 0;
	while ( i < sizeof(initPara) ) {
		uint8_t cmd = pgm_read_byte( &initPara[i++] );
		uint8_t len = pgm_read_byte( &initPara[i++] );
		if ( cmd == 0 ) {
			WAIT_MS( len );
		} else {
			LCD_CMD = cmd;
			while ( len-- ) {
				LCD_DAT = pgm_read_byte( &initPara[i++] );
			}
		}
	}

	/* ʃNA				*/
	lcdSetBrightness( 0 );
	lcdClear();
	lcdOn();
	lcdSetBrightness( 128 );
}

/*****************************************************************************
*								obNCg̋Pxݒ
* Fuint8_t lv 0     :obNCgOFF
*				   1`254:PWM(傫邢)
*				   255   :obNCgON(펞_)
* ߒlFvoid
*****************************************************************************/
void lcdSetBrightness( uint8_t lv )
{
	/* PWM WX^ݒ				*/
	if ( ( lv == 0 ) || ( lv == 255 ) ) {	/* PWM OFF						*/
		TCCR0A = 0;
		TCCR0B = 0;
		TCNT0 = 0;

	} else if ( TCCR0A == 0 ) {				/* PWM ON						*/
		TCCR0A = _BV(COM0A1) | _BV(COM0A0) | _BV(WGM00);
		TCCR0B = 3;
		TCNT0 = 0;
	}

	/* LED|[gݒ				*/
	if ( lv == 0 ) {						/* obNCg				*/
		PORTB &= ~_BV(7);

	} else if ( lv == 255 ) {				/* obNCg_				*/
		PORTB |= _BV(7);

	} else {								/* PWM 						*/
		OCR0A = ( 255 - lv );
	}
}

/*****************************************************************************
*									LCD\ON
* Fvoid
* ߒlFvoid
*****************************************************************************/
void lcdOn( void )
{
	LCD_CMD = LCD_DISPON;
	WAIT_MS( 120 );
}

/*****************************************************************************
*									LCD\OFF
* Fvoid
* ߒlFvoid
*****************************************************************************/
void lcdOff( void )
{
	LCD_CMD = LCD_DISPOFF;
	WAIT_MS( 120 );
}

/*****************************************************************************
*								LCD\NA
* Fvoid
* ߒlFvoid
*****************************************************************************/
void lcdClear( void )
{
	LCD_SET_COLUM_ADDRESS( 0 ,127 );
	LCD_SET_ROW_ADDRESS( 0 ,127 );
	LCD_CMD = LCD_RAMWR;

	uint16_t i = 128 * 128;
	while ( i-- ) {
		LCD_DAT = 0;
		LCD_DAT = 0;
	}
}

#if ( LCD_USE_GRAPHIC != 0 )
/*****************************************************************************
*							_vbg
* Fuint8_t  x     XW(0`127)
*       uint8_t  y     YW(0`127)
*       uint16_t color \F
* ߒlFvoid
*****************************************************************************/
void lcdPset( uint8_t x ,uint8_t y ,uint16_t color )
{
	if ( ( x <= 127 ) && ( y <= 127 ) ) {
		LCD_SET_COLUM_ADDRESS( x ,x );
		LCD_SET_ROW_ADDRESS( y ,y );
		LCD_CMD = LCD_RAMWR;
		LCD_WORD_WRITE( color );
	}
}
#endif	// LCD_USE_GRAPHIC != 0

#if ( LCD_USE_GRAPHIC != 0 )
/*****************************************************************************
*							hԂ`\
* Fuint8_t  x1    X1W(0`127)
*		uint8_t  y1	   Y1W(0`127)
*		uint8_t  x2    X2W(0`127)
*		uint8_t  y2	   Y2W(0`127)
*		uint16_t color \F
* ߒlFvoid
*****************************************************************************/
void lcdFillBox( uint8_t x1 ,uint8_t y1 ,uint8_t x2 ,uint8_t y2 ,uint16_t color )
{
	uint8_t i;

	/* `WNbsO			*/
	lcdRectClip( &x1 ,&y1 ,&x2 ,&y2 );

	/* XJnW/XIWݒ		*/
	LCD_SET_COLUM_ADDRESS( x1 ,x2 );
	LCD_SET_ROW_ADDRESS( y1 ,y2 );

	/* `惁C					*/
	LCD_CMD = LCD_RAMWR;
	while ( y1 <= y2 ) {
		for ( i = x1 ;i <= x2 ;i++ ) {
			LCD_WORD_WRITE( color );
		}
		y1++;
	}
}
#endif	// LCD_USE_GRAPHIC != 0

#if ( LCD_USE_GRAPHIC != 0 )
/*****************************************************************************
*								`\
* Fuint8_t  x1    X1W(0`127)
*		uint8_t  y1	   Y1W(0`127)
*		uint8_t  x2    X2W(0`127)
*		uint8_t  y2	   Y2W(0`127)
*		uint16_t color \F
* ߒlFvoid
*****************************************************************************/
void lcdBox( uint8_t x1 ,uint8_t y1 ,uint8_t x2 ,uint8_t y2 ,uint16_t color )
{
	uint8_t i;

	/* `WNbsO			*/
	lcdRectClip( &x1 ,&y1 ,&x2 ,&y2 );

	/* `惁C					*/
	for ( i = x1 ;i <= x2 ;i++ ) {
		lcdPset( i ,y1 ,color );
		lcdPset( i ,y2 ,color );
	}

	for ( i = y1 ;i <= y2 ;i++ ) {
		lcdPset( x1 ,i ,color );
		lcdPset( x2 ,i ,color );
	}
}
#endif	// LCD_USE_GRAPHIC != 0

#if ( LCD_USE_GRAPHIC != 0 )
/*****************************************************************************
*				\(Bresenham̐`ASY)
* Fuint8_t  x1    n_XW(0`127)
*		uint8_t  y1	   n_YW(0`127)
*		uint8_t  x2    I_XW(0`127)
*		uint8_t  y2	   I_YW(0`127)
*		uint16_t color \F
* ߒlFvoid
*****************************************************************************/
void lcdLine( uint8_t x1 ,uint8_t y1 ,uint8_t x2 ,uint8_t y2 ,uint16_t color )
{
	uint8_t dx = 0;					/* X1,X2̍Βl					*/
	uint8_t dy = 0;					/* Y1,Y2̍Βl					*/
	uint8_t sx = 0;					/* XWړ 0:ړ 1: 2:E	*/
	uint8_t sy = 0;					/* YWړ 0:ړ 1: 2:	*/
	uint8_t e = 0;					/* 덷									*/
	uint8_t i;						/* 厲WJE^						*/

	/* X1,X2̐ΒlXړvZ	*/
	if ( x1 > x2 ) {
		dx = x1 - x2;
		sx = 1;
	} else if ( x1 < x2 ) {
		dx = x2 - x1;
		sx = 2;
	}

	/* Y1,Y2̐ΒlYړvZ	*/
	if ( y1 > y2 ) {
		dy = y1 - y2;
		sy = 1;
	} else if ( y1 < y2 ) {
		dy = y2 - y1;
		sy = 2;
	}

	/* ̑傫厲Ƃ	*/
	if ( dx >= dy ) {
		for ( i = 0 ;i <= dx ;i++ ) {
			lcdPset( x1 ,y1 ,color );
			e += dy;
			if ( e > dx ) {
				e -= dx;
				if ( sy == 1 ) {
					y1--;
				} else if ( sy == 2 ) {
					y1++;
				}
			}
			if ( sx == 1 ) {
				x1--;
			} else if ( sx == 2 ) {
				x1++;
			}
		}

	} else {
		for ( i = 0 ;i <= dy ;i++ ) {
			lcdPset( x1 ,y1 ,color );
			e += dx;
			if ( e > dy ) {
				e -= dy;
				if ( sx == 1 ) {
					x1--;
				} else if ( sx == 2 ) {
					x1++;
				}
			}
			if ( sy == 1 ) {
				y1--;
			} else if ( sy == 2 ) {
				y1++;
			}
		}
	}
}
#endif	// LCD_USE_GRAPHIC != 0

/****************************************************************************
*							ASCII\( 5x7 )
* Fuint8_t  x         \JnXW
*		uint8_t  y         \JnYW
*		char     c		   \R[h
*		uint16_t fontColor \F
*		uint16_t bgColor   wiF
* ߒlFvoid
****************************************************************************/
void lcdPutc( uint8_t x ,uint8_t y ,char c ,uint16_t fontColor ,uint16_t bgColor )
{
	const prog_uint8_t *p;
	uint8_t x1 = x;
	uint8_t y1 = y;
	uint8_t x2 = ( x1 + 5 - 1 ) + 1;
	uint8_t y2 = ( y1 + 7 - 1 );
	uint8_t dat;

	/* R[hɑΉf[^e[uʒu擾	*/
	if ( ( (uint8_t)c >= 0x20 ) && ( (uint8_t)c <= 0x8a ) ) {
		p = &font[ ( (uint16_t)c - 32 ) * 7 ];
	} else if ( ( (uint8_t)c >= 0xa1 ) && ( (uint8_t)c <= 0xdf ) ) {
		p = &font[ ( (uint16_t)c - 54 ) * 7 ];
	} else {
		p = font;
	}

	/* \̈ݒ									*/
	LCD_SET_COLUM_ADDRESS( x1 ,x2 );
	LCD_SET_ROW_ADDRESS( y1 ,y2 );
	LCD_CMD = LCD_RAMWR;

	for ( y = y1 ;( ( y <= y2 ) && (y < 128 ) ) ;y++ ) {
		dat = pgm_read_byte( p++ );
		for ( x = x1 ;( ( x <= x2 ) && ( x < 128 ) ) ;x++ ) {
			if ( dat & 0x80 ) {
				LCD_WORD_WRITE( fontColor );
			} else {
				LCD_WORD_WRITE( bgColor );
			}
			dat <<= 1;
		}
	}
}

/****************************************************************************
*						ASCIItHg(5x7)f[^擾
* Fchar            c    R[h
* ߒlFconst prog_uint8_t * tHg̈ւ̃|C^
****************************************************************************/
const prog_uint8_t *lcdGetFontImage( char c )
{
	const prog_uint8_t *p;

	/* R[hɑΉf[^e[uʒu擾	*/
	if ( ( (uint8_t)c >= 0x20 ) && ( (uint8_t)c <= 0x8a ) ) {
		p = &font[ ( (uint16_t)c - 32 ) * 7 ];
	} else if ( ( (uint8_t)c >= 0xa1 ) && ( (uint8_t)c <= 0xdf ) ) {
		p = &font[ ( (uint16_t)c - 54 ) * 7 ];
	} else {
		p = font;
	}

	return ( p );
}

/****************************************************************************
*							ASCII\( 5x7 )
* Fuint8_t  x         \JnXW
*		uint8_t  y         \JnYW
*		char     *str      \
*		uint16_t fontColor \F
*		uint16_t bgColor   wiF
* ߒlFvoid
****************************************************************************/
void lcdPuts( uint8_t x ,uint8_t y ,char *str ,uint16_t fontColor ,uint16_t bgColor )
{
	uint8_t c;
	while ( ( c = (uint8_t)*str++ ) && ( x < 128 ) ) {
		lcdPutc( x ,y ,c ,fontColor ,bgColor );
		x += 6;
	}
}

void lcdPuts_P( uint8_t x ,uint8_t y ,const prog_char *str ,uint16_t fontColor ,uint16_t bgColor )
{
	uint8_t c;
	while ( ( c = pgm_read_byte(str++) ) && ( x < 128 ) ) {
		lcdPutc( x ,y ,c ,fontColor ,bgColor );
		x += 6;
	}
}

/****************************************************************************
*					Cӂ̋`WNbsO
* Fuint8_t x1   `̍XW
*		uint8_t y1   `̍YW
*		uint8_t y2   `̉EXW
*		uint8_t y2   `̉EYW
* ߒlFvoid
****************************************************************************/
void lcdRectClip( uint8_t *x1 ,uint8_t *y1 ,uint8_t *x2 ,uint8_t *y2 )
{
	uint8_t swap;

	/* WNbsO				*/
	if ( *x1 >= 128 ) {
		*x1 = 127;
	}

	if ( *x2 >= 128 ) {
		*x2 = 127;
	}

	if ( *y1 >= 128 ) {
		*y1 = 127;
	}

	if ( *y2 >= 128 ) {
		*y2 = 127;
	}

	/* Kvȏꍇ͍WXbv	*/
	if ( *x1 > *x2 ) {
		swap = *x1;
		*x1 = *x2;
		*x2 = swap;
	}

	if ( *y1 > *y2 ) {
		swap = *y1;
		*y1 = *y2;
		*y2 = swap;
	}
}

